Package: padr
Type: Package
Title: Quickly Get Datetime Data Ready for Analysis
Version: 0.6.2
Author: Edwin Thoen
Maintainer: Edwin Thoen <edwinthoen@gmail.com>
Description: Transforms datetime data into a format ready for analysis.
    It offers two core functionalities; aggregating data to a higher level interval
    (thicken) and imputing records where observations were absent (pad). 
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.0.0)
Imports: Rcpp, dplyr (>= 1.0.0), lubridate, rlang
Suggests: ggplot2, testthat, knitr, rmarkdown, lazyeval, tidyr,
        data.table
RoxygenNote: 7.1.0
LinkingTo: Rcpp
VignetteBuilder: knitr
URL: https://github.com/EdwinTh/padr
BugReports: https://github.com/EdwinTh/padr/issues
ByteCompile: true
NeedsCompilation: yes
Packaged: 2022-11-23 15:08:44 UTC; edwinthoen
Repository: CRAN
Date/Publication: 2022-11-23 16:00:02 UTC
Built: R 4.4.1; x86_64-apple-darwin24.0.0; 2024-10-12 08:34:23 UTC; unix

## ---- fig.width = 7, message=FALSE, warning=FALSE-----------------------------
library(padr); library(dplyr); library(ggplot2)
veh_acc <- emergency %>% 
  filter(title == "Traffic: VEHICLE ACCIDENT -",
         lubridate::month(time_stamp) %in% 4:6) 

veh_acc_line_plot <- function(padded_df,
                              units_to_last = NULL) {
  padded_df %>% 
  fill_by_value() %>% 
  thicken("day", "day") %>% 
  mutate(interval = format_interval(day_hour, "%H", sep = "-" , 
                                    units_to_last = units_to_last)) %>% 
  ggplot(aes(day, n)) + 
  facet_wrap(~interval) +
  geom_line() 
}

veh_acc %>%
  thicken("3 hour", "day_hour") %>% 
  count(day_hour) %>% 
  pad() %>% 
  veh_acc_line_plot()

## -----------------------------------------------------------------------------
veh_acc_span <- 
  span_around(veh_acc$time_stamp, interval = "hour", start_shift = "7 hour") %>% 
  subset_span(list(hour = c(7, 10, 16, 19)))

## -----------------------------------------------------------------------------
veh_acc_cust <- veh_acc %>% 
  thicken_cust(spanned = veh_acc_span, colname = "day_hour") %>% 
  count(day_hour) %>% 
  pad_cust(veh_acc_span)

## ---- fig.width=7-------------------------------------------------------------
veh_acc_line_plot(veh_acc_cust, units_to_last = 12 * 3600)

date_span <- span_date(20161226, len_out = 10)
time_span <- span_time("20170101 00", len_out = 10)
min_span  <- span_time("20170101 0000", len_out = 10)
sec_span  <- span_time("20170101 000000", len_out = 10)
context("Check proper error handling wrong inputs subset_span")

test_that("function breaks on wrong names in span_list", {
  expect_error(subset_span(date_span, list(yr = 1:10)))
  expect_error(subset_span(date_span, list(day = 1:10)))
  expect_error(subset_span(date_span, list(year = 1:10)), NA)
  expect_error(subset_span(date_span, list(mon = 1:10)), NA)
  expect_error(subset_span(date_span, list(wday = 1:3)), NA)
  expect_error(subset_span(date_span, list(mday = 1:10)), NA)
  expect_error(subset_span(time_span, list(hour = 1:10)), NA)
  expect_error(subset_span(time_span, list(min = 1:10)), NA)
  expect_error(subset_span(time_span, list(sec = 1:10)), NA)
})

test_that("function breaks on wrong input", {
  expect_error(subset_span(1:10, list(year = 1:10)),
               "x is not of class POSIXct, POSIXlt, or Date")
  expect_error(subset_span(TRUE, list(year = 1:10)),
               "x is not of class POSIXct, POSIXlt, or Date")
  expect_error(subset_span("2016-01-01", list(year = 1:10)),
               "x is not of class POSIXct, POSIXlt, or Date")
  expect_error(subset_span(20160101, list(year = 1:10)),
               "x is not of class POSIXct, POSIXlt, or Date")
  expect_error(subset_span(date_span, list(year = 1:10)), NA)
  expect_error(subset_span(time_span, list(year = 1:10)), NA)
})

context("Check subset_span on expected output")
test_that("subset_span gives the correct output", {
  expect_equal(subset_span(date_span, list(year = 2016)),
               date_span[1:6])
  expect_equal(subset_span(date_span, list(mon = 12)),
               date_span[1:6])
  expect_equal(subset_span(date_span, list(wday = 1)),
               date_span[c(1, 8)])
  expect_equal(subset_span(date_span, list(mday = 26:31)),
               date_span[1:6])
  expect_equal(subset_span(time_span, list(hour = 0:4)),
               time_span[1:5])
  expect_equal(subset_span(min_span, list(min = 0:4)),
               min_span[1:5])
  expect_equal(subset_span(sec_span, list(sec = 0:4)),
               sec_span[1:5])
})

source("library.R")

a_date <- ymd(c("20151201", "20160201"))
a_ct <- ymd_h(c("20151201 03", "20160201 03"))
b_date <- span(a_date, convert_interval("month"))
b_ct   <- ymd_hms(c("2015-01-01 00:00:00", "2016-01-01 00:00:00",
                    "2017-01-01 00:00:00"))
b_ct_tz_is_NULL <- b_ct
attr(b_ct_tz_is_NULL, 'tzone') <- NULL

context("to_posix creates correct result")
test_that("to_posix sets second to posix if first is", {
  date_date   <- to_posix(a_date, b_date)
  posix_date  <- to_posix(a_ct, b_date)
  date_posix  <- to_posix(a_date, b_ct)
  posix_posix <- to_posix(a_ct, b_ct)
  date_posix_tz_null <- to_posix(a_date, b_ct_tz_is_NULL)
  posix_date_tz_null <- to_posix(b_ct_tz_is_NULL, a_date)
  expect_equal( date_date$a %>% class, "Date")
  expect_equal( date_date$b %>% class, "Date")
  expect_equal( posix_date$a %>% class, c("POSIXct", "POSIXt"))
  expect_equal( posix_date$b %>% class, c("POSIXct", "POSIXt"))
  expect_equal( date_posix$a %>% class, c("POSIXct", "POSIXt"))
  expect_equal( date_posix$b %>% class, c("POSIXct", "POSIXt"))
  expect_equal( posix_posix$a %>% class, c("POSIXct", "POSIXt"))
  expect_equal( posix_posix$b %>% class, c("POSIXct", "POSIXt"))
  expect_equal( date_posix_tz_null$a %>% class, c("POSIXct", "POSIXt"))
  expect_equal( date_posix_tz_null$b %>% class, c("POSIXct", "POSIXt"))
})


context("round_up_core and round_down_core work as expected")
test_that("round_up_core gives correct result", {
  expect_equal( round_up_core(a_date, b_date),
                as.numeric (as.Date ( c("2016-01-01",  "2016-03-01"))))
  expect_equal( round_up_core(a_ct, b_ct),
                as.numeric (ymd_hms ( c("2016-01-01 00:00:00",
                                        "2017-01-01 00:00:00"))))
})

test_that("round_down_core gives correct result", {
  expect_equal( round_down_core(a_date, b_date),
                as.numeric (as.Date ( c("2015-12-01",  "2016-02-01"))))
  expect_equal( round_down_core(a_ct, b_ct),
                as.numeric (ymd_hms ( c("2015-01-01 00:00:00",
                                        "2016-01-01 00:00:00"))))
})

context("posix_to_date works as expected")
test_that("posix_to_date gives date when possible", {
  expect_equal( posix_to_date(a_date) %>% class, "Date" )
  expect_equal( posix_to_date(a_ct) %>% class, c("POSIXct", "POSIXt"))
  expect_equal( posix_to_date(b_ct) %>% class, "Date" )
})

source("library.R")

context("Check all argument combinations in thicken")

test_that("interval: year", {
  coffee_year    <- coffee
  year(coffee_year$time_stamp)[3:4] <- 2017:2018
  coffee_year_2_dts <- coffee_year
  coffee_year_2_dts$ts2 <- coffee_year_2_dts$time_stamp
  year_thickened_down <- ymd(c(20160101, 20160101, 20170101, 20180101))
  year_thickened_up   <- ymd(c(20170101, 20170101, 20180101, 20190101))

  s <- ymd(20151231)

  # plain
  expect_equal(thicken(coffee_year, "year")$time_stamp_year,
               year_thickened_down)
  # specify colname
  expect_equal(thicken(coffee_year, "year", "y")$y,
               year_thickened_down)
  # rounding up
  expect_equal(thicken(coffee_year, "year", rounding = "up")$time_stamp_year,
               year_thickened_up)
  # specify by
  expect_equal(thicken(coffee_year_2_dts, "year", by = "ts2")$ts2_year,
               year_thickened_down)
  # start_val
  expect_equal(thicken(coffee_year, "year", start_val = s)$time_stamp_year,
               year_thickened_down - 1)
  # interval abbreviation
  expect_equal(thicken(coffee_year, "y")$time_stamp_year,
               year_thickened_down)
  # specify by rounding up
  expect_equal(thicken(coffee_year_2_dts, "year", rounding = "up", by = "ts2")$ts2_year,
               year_thickened_up)
  # specify by specify colname
  expect_equal(thicken(coffee_year_2_dts, "year", colname = "t", by = "ts2")$t,
               year_thickened_down)
  # specify by start_val
  expect_equal(thicken(coffee_year_2_dts, "year", by = "ts2", start_val = s)$ts2_year,
               year_thickened_down - 1)
  # specify by interval abbreviation
  expect_equal(thicken(coffee_year_2_dts, "y", by = "ts2", start_val = s)$ts2_year,
               year_thickened_down - 1)
  # rounding up     specify colname
  expect_equal(thicken(coffee_year, "year", "jos", rounding = "up")$jos,
               year_thickened_up)
  # rounding up     start_val
  expect_equal(thicken(coffee_year, "year", rounding = "up", start_val = s)$time_stamp_year,
               year_thickened_up - 1)
  # rounding up     interval abbreviation
  expect_equal(thicken(coffee_year, "y", rounding = "up")$time_stamp_year,
               year_thickened_up)
  # specify colname start_val
  expect_equal(thicken(coffee_year, "year", "jos", start_val = s)$jos,
               year_thickened_down - 1)
  # specify colname interval abbreviation
  expect_equal(thicken(coffee_year, "y", "jos")$jos,
               year_thickened_down)
  # start_val       interval abbreviation
  expect_equal(thicken(coffee_year, "y", start_val = s)$time_stamp_year,
               year_thickened_down - 1)
})

test_that("interval: month", {
  coffee_month    <- coffee
  month(coffee_month$time_stamp)[3:4] <- 8:9
  coffee_month_2_dts <- coffee_month
  coffee_month_2_dts$ts2 <- coffee_month_2_dts$time_stamp
  month_thickened_down <- ymd(c(20160701, 20160701, 20160801, 20160901))
  month_thickened_up   <- ymd(c(20160801, 20160801, 20160901, 20161001))

  s <- ymd(20160630)

  # plain
  expect_equal(thicken(coffee_month, "month")$time_stamp_month,
               month_thickened_down)
  # specify colname
  expect_equal(thicken(coffee_month, "month", "m")$m,
               month_thickened_down)
  # rounding up
  expect_equal(thicken(coffee_month, "month", rounding = "up")$time_stamp_month,
               month_thickened_up)
  # specify by
  expect_equal(thicken(coffee_month_2_dts, "month", by = "ts2")$ts2_month,
               month_thickened_down)
  # start_val
  expect_equal(thicken(coffee_month, "month", start_val = s)$time_stamp_month,
               month_thickened_down - c(1, 1, 2, 2))
  # interval abbreviation
  expect_equal(thicken(coffee_month, "mo")$time_stamp_month,
               month_thickened_down)
  # specify by rounding up
  expect_equal(thicken(coffee_month_2_dts, "month", rounding = "up", by = "ts2")$ts2_month,
               month_thickened_up)
  # specify by specify colname
  expect_equal(thicken(coffee_month_2_dts, "month", colname = "t", by = "ts2")$t,
               month_thickened_down)
  # specify by start_val
  expect_equal(thicken(coffee_month_2_dts, "month", by = "ts2", start_val = s)$ts2_month,
               month_thickened_down - c(1, 1, 2, 2))
  # specify by interval abbreviation
  expect_equal(thicken(coffee_month_2_dts, "mo", by = "ts2")$ts2_month,
               month_thickened_down)
  # rounding up     specify colname
  expect_equal(thicken(coffee_month, "month", "jos", rounding = "up")$jos,
               month_thickened_up)
  # rounding up     start_val
  expect_equal(thicken(coffee_month, "month", rounding = "up", start_val = s)$time_stamp_month,
               month_thickened_up - c(2, 2, 2, 1))
  # rounding up     interval abbreviation
  expect_equal(thicken(coffee_month, "mo", rounding = "up")$time_stamp_month,
               month_thickened_up)
  # specify colname start_val
  expect_equal(thicken(coffee_month, "month", "jos", start_val = s)$jos,
               month_thickened_down - c(1, 1, 2, 2))
  # specify colname interval abbreviation
  expect_equal(thicken(coffee_month, "mo", "jos")$jos,
               month_thickened_down)
  # start_val       interval abbreviation
  expect_equal(thicken(coffee_month, "mo", start_val = s)$time_stamp_month,
               month_thickened_down - c(1, 1, 2, 2))
})

test_that("interval: day", {
  coffee_day  <- data.frame(
    time_stamp = ymd_hms(c("2016-07-07 09:11:21", "2016-07-07 09:46:48",
                           "2016-07-09 13:25:17", "2016-07-10 10:45:11")),
    y = c(3.14, 2.98, 4.11, 3.14))
  coffee_day_2_dts <- coffee_day
  coffee_day_2_dts$ts2 <- coffee_day_2_dts$time_stamp
  day_thickened_down <- ymd(c(20160707, 20160707, 20160709, 20160710))
  day_thickened_down_s <- ymd_h(c("20160706 23", "20160706 23",
                                  "20160708 23", "20160709 23"))
  day_thickened_up   <- ymd(c(20160708, 20160708, 20160710, 20160711))

  s <- ymd_h("20160706 23")

  # plain
  expect_equal(thicken(coffee_day, "day")$time_stamp_day,
               day_thickened_down)
  # specify colname
  expect_equal(thicken(coffee_day, "day", "m")$m,
               day_thickened_down)
  # rounding up
  expect_equal(thicken(coffee_day, "day", rounding = "up")$time_stamp_day,
               day_thickened_up)
  # specify by
  expect_equal(thicken(coffee_day_2_dts, "day", by = "ts2")$ts2_day,
               day_thickened_down)
  # start_val
  expect_equal(suppressWarnings(thicken(coffee_day, "day", start_val = s))$time_stamp_day,
               day_thickened_down_s)
  # interval abbreviation
  expect_equal(thicken(coffee_day, "d")$time_stamp_day,
               day_thickened_down)
  # specify by rounding up
  expect_equal(thicken(coffee_day_2_dts, "day", rounding = "up", by = "ts2")$ts2_day,
               day_thickened_up)
  # specify by specify colname
  expect_equal(thicken(coffee_day_2_dts, "day", colname = "t", by = "ts2")$t,
               day_thickened_down)
  # specify by start_val
  expect_equal(suppressWarnings(thicken(coffee_day_2_dts, "day",
                                        by = "ts2", start_val = s))$ts2_day,
               day_thickened_down_s)
  # specify by interval abbreviation
  expect_equal(thicken(coffee_day_2_dts, "d", by = "ts2")$ts2_day,
               day_thickened_down)
  # rounding up     specify colname
  expect_equal(thicken(coffee_day, "day", "jos", rounding = "up")$jos,
               day_thickened_up)
  # rounding up     start_val
  expect_equal(suppressWarnings(thicken(coffee_day, "day", rounding = "up",
                                        start_val = s))$time_stamp_day,
               day_thickened_down_s + 3600 * 24)
  # rounding up     interval abbreviation
  expect_equal(thicken(coffee_day, "d", rounding = "up")$time_stamp_day,
               day_thickened_up)
  # specify colname start_val
  expect_equal(suppressWarnings(thicken(coffee_day, "day", "jos",
                                        start_val = s))$jos,
               day_thickened_down_s)
  # specify colname interval abbreviation
  expect_equal(thicken(coffee_day, "d", "jos")$jos,
               day_thickened_down)
  # start_val       interval abbreviation
  expect_equal(suppressWarnings(thicken(coffee_day, "d",
                                        start_val = s))$time_stamp_day,
               day_thickened_down_s)
})

test_that("interval: hour", {
  coffee_hour       <- data.frame(
    time_stamp = ymd_hms(c("2016-07-07 09:11:21", "2016-07-07 09:46:48",
                           "2016-07-09 13:25:17", "2016-07-10 10:45:11")),
    y = c(3.14, 2.98, 4.11, 3.14))
  coffee_hour$time_stamp <- ymd_hms(as.character(coffee_hour$time_stamp))
  coffee_hour_2_dts <- coffee_hour
  coffee_hour_2_dts$ts2 <- coffee_hour_2_dts$time_stamp
  hour_thickened <- ymd_h(c("2016-07-07 09", "2016-07-07 09",
                            "2016-07-09 13", "2016-07-10 10"))
  hour_thickened_up <- ymd_h(c("2016-07-07 10", "2016-07-07 10",
                               "2016-07-09 13", "2016-07-10 11"))
  hour_thickened_down_s <- ymd_hm(c("2016-07-07 08:59", "2016-07-07 08:59",
                            "2016-07-09 12:59", "2016-07-10 09:59"))
  s <- ymd_hm("2016-07-07 8:59")
  # plain
  expect_equal(thicken(coffee_hour, "hour")$time_stamp_hour,
               hour_thickened)
  # specify colname
  expect_equal(thicken(coffee_hour, "hour", "h")$h,
               hour_thickened)
  # rounding up
  expect_equal(thicken(coffee_hour, "hour", rounding = "up")$time_stamp_hour,
               hour_thickened + 3600)
  # specify by
  expect_equal(thicken(coffee_hour_2_dts, "hour", by = "ts2")$ts2_hour,
               hour_thickened)
  # start_val
  expect_equal(thicken(coffee_hour, "hour", start_val = s)$time_stamp_hour,
               hour_thickened - 60)
  # interval abbreviation
  expect_equal(thicken(coffee_hour, "h")$time_stamp_hour,
               hour_thickened)
  # specify by rounding up
  expect_equal(thicken(coffee_hour_2_dts, "hour", rounding = "up", by = "ts2")$ts2_hour,
               hour_thickened + 3600)
  # specify by specify colname
  expect_equal(thicken(coffee_hour_2_dts, "hour", colname = "t", by = "ts2")$t,
               hour_thickened)
  # specify by start_val
  expect_equal(thicken(coffee_hour_2_dts, "hour", by = "ts2", start_val = s)$ts2_hour,
               hour_thickened - 60)

  # specify by interval abbreviation
  expect_equal(thicken(coffee_hour_2_dts, "h", by = "ts2", start_val = s)$ts2_hour,
               hour_thickened - 60)
  # rounding up     specify colname
  expect_equal(thicken(coffee_hour, "hour", "jos", rounding = "up")$jos,
               hour_thickened + 3600)
  # rounding up     start_val
  expect_equal(thicken(coffee_hour, "hour", rounding = "up", start_val = s)$time_stamp_hour,
               hour_thickened + 3540)
  # rounding up     interval abbreviation
  expect_equal(thicken(coffee_hour, "h", rounding = "up")$time_stamp_hour,
               hour_thickened + 3600)
  # specify colname start_val
  expect_equal(thicken(coffee_hour, "hour", "jos", start_val = s)$jos,
               hour_thickened - 60)
  # specify colname interval abbreviation
  expect_equal(thicken(coffee_hour, "h", "jos")$jos,
               hour_thickened)
  # start_val       interval abbreviation
  expect_equal(thicken(coffee_hour, "h", start_val = s)$time_stamp_hour,
               hour_thickened - 60)
})

source("library.R")
no_dt <- data.frame(x = 1:2, y = c("A", "B"))
one_dt <- data.frame(x = 1:2, y = c("A", "B"), dt1 = ymd(c(20160401, 20160803)))
two_dt <- data.frame(x = 1:2, y = c("A", "B"), dt1 = ymd(c(20160401, 20160803)),
                     dt2 = ymd_h(c("20160401 01", "20160803 05")))

context("check_date_variables does what is expecterd")
test_that("check_date_variables works correctly when by is specified", {
  expect_error( check_data_frame( no_dt, by = "dt3") )
  expect_error( check_data_frame( one_dt, by = "dt3") )
  expect_error( check_data_frame( two_dt, by = "dt3") )
  expect_equal( check_data_frame( one_dt, by = "dt1"),
                ymd(c(20160401, 20160803)))
  expect_equal( check_data_frame( two_dt, by = "dt1"),
                ymd(c(20160401, 20160803)))
})

test_that("check_date_variables works correctly when by is not specified", {
  expect_equal( check_data_frame( one_dt), ymd(c(20160401, 20160803)))
  expect_error( check_data_frame( no_dt) )
  expect_error( check_data_frame( two_dt) )
})

source("library.R")

date_seq <- function(interval){
  set.seed(1234)
  # only use a wide interval to test year, all others less wide for performance
  if (interval == "year") {
    start_date <- as.POSIXlt(strftime("2005-01-01"))
  } else {
    start_date <- as.POSIXlt(strftime("2015-01-01"))
  }

  sequence <- seq(start_date,
                  as.POSIXlt(strftime("2017-01-01")),
                  by = interval)

  set.seed(12345)
  if (length(sequence) > 100) {
    sampled_dates <- sample(sequence, 100)
  } else {
    sampled_dates <- sample(sequence, length(sequence) / 2)
  }
  return(sampled_dates)
}

x_month <- date_seq("month")
x_day   <- date_seq("DSTday")
x_hour  <- date_seq("hour")
x_min   <- date_seq("min")
x_sec   <- date_seq("sec")
equal_dist <- c(as.POSIXct("2014-01-01 23:00:00"),
                as.POSIXct("2014-01-02 01:00:00"))

df_with_one_date  <- data.frame(dt_var1 = date_seq("month"),
                                y = 1:6)
df_with_one_date_sorted <- df_with_one_date %>% arrange(dt_var1)
df_with_two_dates <- data.frame(dt_var1  = date_seq("month"),
                                dt_var2 = date_seq("month"),
                                y = 1:6)
x_month <- data.frame(x = ymd(c(20160201, 20160301)))
x_month_unordered  <- data.frame(x = ymd(c(20160301, 20160201)))
sw <- suppressWarnings

context("thicken function errors and warnings")

test_that("thicken only accepts data frames", {
  expect_error(thicken(x_month %>% as.character))
  expect_error(thicken(x_month %>% as.numeric))
  expect_error(suppressWarnings(thicken(df_with_one_date, interval = "quarter")), NA)
})

test_that("thicken throws warning when asked interval is lower", {
  expect_warning(thicken(x_month, interval = "month"))
  expect_warning(thicken(x_month, interval = "day"))
  expect_error(thicken(x_month, interval = "year"), NA)
})

test_that("thicken gives informed error when start_val is wrong class", {
  expect_error(thicken(x_month, start_val = "2017-01-01",
               "start_val should be of class Date, POSIXlt, or POSIXct"))
})

test_that("thicken removes when start_val is larger than min(dt)", {
  x <- data.frame(dt = as.Date(c("2016-01-01", "2016-01-03", "2016-01-04")),
                  y = 1:3)
  expect_equal(thicken(x, start_val = as.Date("2016-01-02"), interval = "year")  %>%
                  nrow, 2)
})

context("thicken integration tests")

test_that("thicken gives correct interval", {
  x_df <- data.frame(x_sec = x_sec)
  expect_equal(sw(thicken(x_df, interval = "year"))$x_sec_year %>% get_interval,
               "year")
  expect_equal(sw(thicken(x_df, interval = "month"))$x_sec_month %>% get_interval,
               "month")
  expect_equal(sw(thicken(x_df, interval = "day"))$x_sec_day %>% get_interval,
               "day")
  expect_equal(sw(thicken(x_df, interval = "hour"))$x_sec_hour %>% get_interval,
               "hour")
  expect_equal(sw(thicken(x_df, interval = "min"))$x_sec_min %>% get_interval,
               "min")
})

test_that("thicken gives correct output when x is a vector", {
  day_sorted <- sort(x_day)
  day_to_year <- thicken(day_sorted %>% as.data.frame, colname = "x", interval = "year")$x
  day_to_year2 <- thicken(day_sorted %>% as.data.frame, "x", interval = "year",
                          rounding = "up")$x

  expect_equal(day_to_year %>% length, 100)
  expect_equal(lubridate::year(day_to_year[1]), 2015)
  expect_equal(lubridate::year(day_to_year[100]), 2016)
  expect_equal(lubridate::year(day_to_year2[1]), 2016)
  expect_equal(lubridate::year(day_to_year2[100]), 2017)
})

test_that("thicken gives correct ouput when x is a df", {
  X <- data.frame(day_var = seq(as.Date("2016-01-01"), as.Date("2016-12-31"), by = "day"), #nolint
                  value   = runif(366, 50, 100))

  expect_equal(thicken(X, interval = "month") %>% nrow, 366)
  expect_equal( lubridate::month(thicken(X, interval = "month")$day_var_month) %>% max, 12) #nolint
  expect_error( (thicken(dplyr::as_tibble(X), interval = "month")), NA)
  expect_error( thicken(data.table::as.data.table(X), interval = "month"), NA)
})

test_that("column naming works properly", {
  a <- sort(x_day)
  a_df <- data.frame(a = a, b = 42)
  expect_equal(colnames(thicken(a_df, interval = "week"))[3], "a_week")
  expect_equal(colnames(thicken(a_df, interval = "2 days", colname = "jos"))[3], "jos")
})


context("test set_to_original_type")

test_that("set_to_original_type returns tbl or data.table", {
  expect_equal(sw(dplyr::as_tibble(df_with_one_date) %>% thicken("2 mon") %>% class),
               c("tbl_df", "tbl", "data.frame"))
  expect_equal(sw(data.table::as.data.table(df_with_one_date) %>% thicken("2 mon") %>%
                    class),
               c("data.table", "data.frame"))
})


context("thicken with missing values")

test_that("thicken works properly on NA values", {
  coffee_na <- coffee %>% thicken("day", "d") %>% count(d) %>% pad() %>%
    fill_by_value()
  coffee_na[3, 1] <- NA
  coffee_na_thickened <- sw(coffee_na %>% thicken("week"))
  expect_error(sw(coffee_na %>% thicken("week")), NA)
  expect_warning(coffee_na %>% thicken("week"),
                 "There are NA values in the column d.
Returned dataframe contains original observations, with NA values for d and d_week.")
  expect_equal(coffee_na_thickened %>% nrow, 4)
  expect_equal(coffee_na_thickened %>% filter(is.na(d)) %>% nrow, 1)
  expect_equal(coffee_na_thickened %>% filter(is.na(d_week)) %>% nrow, 1)
  expect_equal(coffee_na_thickened$d[3] %>% as.character(), NA_character_)

  coffee_two_nas <-  coffee %>% thicken("day", "d") %>% count(d) %>% pad() %>%
    fill_by_value()
  coffee_two_nas[c(2, 3), 1] <- NA

  expect_equal(sw(thicken(coffee_two_nas, "week"))$d_week,
               c(as.Date("2016-07-03"), NA, NA, as.Date("2016-07-10")))
})

test_that("add_na_to_thicken unit tests", {
  thickened_date     <- ymd(c(20180101, 20180101))
  thickened_datetime <- ymd_h(c("20180101 01", "20180101 04"))
  thickened_datetime_CET <- as.POSIXct(as.character(thickened_datetime), tz = "CET")


  expect_equal(add_na_to_thicken(thickened_date, 2),
               ymd(c(20180101, NA, 20180101)))
  expect_equal(add_na_to_thicken(thickened_datetime, 2),
               ymd_h(c("20180101 01", NA, "20180101 04")))
  expect_equal(add_na_to_thicken(thickened_date, c(2, 4)),
               ymd(c(20180101, NA, 20180101, NA)))
  expect_equal(add_na_to_thicken(thickened_datetime, c(2, 4)),
               ymd_h(c("20180101 01", NA, "20180101 04", NA)))

  expect_equal(add_na_to_thicken(thickened_datetime_CET, c(2, 4)),
               ymd_h(c("20180101 01", NA, "20180101 04", NA), tz = "CET"))
})

context("thicken drop argument")
test_that("the drop argument gives the desired result", {
  day <- as.Date(c("2016-07-07", "2016-07-07", "2016-07-09", "2016-07-10"))
  coffee_day <- coffee %>% mutate(time_stamp_day = day)
  no_drop <- coffee_day
  with_drop <- coffee_day %>% select(-time_stamp)
  expect_equal(thicken(coffee, "day"), no_drop)
  expect_equal(thicken(coffee, "day", drop = FALSE), no_drop)
  expect_equal(thicken(coffee, "day", drop = TRUE), with_drop)
})

test_that("thicken will return a data frame when drop = TRUE", {
  x <- as.data.frame(coffee[ ,1])
  x_ret <- data.frame(time_stamp_hour = ymd_hms(c("2016-07-07 09:00:00",
                                                  "2016-07-07 09:00:00",
                                                  "2016-07-09 13:00:00",
                                                  "2016-07-10 10:00:00")))
  expect_s3_class(thicken(x, interval = "hour", drop = TRUE), "data.frame")
})

context("ties_to_earlier argument to thicken")
x <- data.frame(
  dt = ymd_hm("20171021 1631", "20171021 1700", "20171021 1731"))

test_that("ties_to_earlier works with rounding down regular",{
  expect_equal(thicken(x, "hour", ties_to_earlier = TRUE)$dt_hour,
               ymd_h("20171021 16", "20171021 16", "20171021 17"))
})

test_that("ties_to_earlier works with rounding up regular", {
  expect_equal(thicken(x, "hour", rounding = "up", ties_to_earlier = TRUE)$dt_hour,
               ymd_h("20171021 17", "20171021 17", "20171021 18"))
})

test_that("ties_to_earlier works with rounding down ties on edges", {
  expect_equal(thicken(x[2:3, ,drop = FALSE], "hour", ties_to_earlier = TRUE)$dt_hour,
               ymd_h("20171021 16", "20171021 17"))
})

test_that("ties_to_earlier works with rounding up ties on edges", {
  expect_equal(thicken(x[1:2, ,drop = FALSE], "hour", rounding = "up", ties_to_earlier = TRUE)$dt_hour,
               ymd_h("20171021 17", "20171021 17"))
})


context("informative error for Year 2038 problem")
x <- data.frame(dt = ymd_h("20381201 01", "20381202 01"))
expect_error(thicken(x, "hour"),
             "thicken does not work on POSIX data after 2038, due to Year 2038 problem. https://en.wikipedia.org/wiki/Year_2038_problem")

y <- data.frame(d = as.Date(c("2038-12-10", "2038-12-13")))
expect_error(thicken(y, interval = "1 month"), NA)

source("library.R")

# standard inputs for class testing
day_vec <- as.Date(c("2016-01-01", "2016-02-29"))
posix_ct <- as.POSIXct(c("2016-01-01 21:19:53", "2016-02-29 10:16:11"))
posix_lt <- as.POSIXlt(c("2016-01-01 21:19:53", "2016-02-29 10:16:11"))
one_posix <- as.POSIXlt("2016-02-17 21:19:53")

generate_interval <- function(unit, int) {
  list(interval = int, step = unit)
}

context("span fails on wrong input")

test_that("span fails on non-datetime vectors", {
  expect_error(as.integer(day_vec) %>% span)
  expect_error(as.numeric(day_vec) %>% span)
  expect_error(as.character(day_vec) %>% span)
  expect_error(as.factor(day_vec) %>% span)
})

test_that("span fails on data.frames", {
  expect_error(mtcars %>% span)
})

test_that("span does not fail on Date, POSIXct and POSIXlt", {
  expect_error(day_vec %>% span(generate_interval(1, "day")), NA)
  expect_error(posix_ct %>% span(generate_interval(1, "sec")), NA)
  expect_error(posix_lt %>% span(generate_interval(1, "sec")), NA)
})


context("units of the get_interval funcition")

test_that("next_ gives correct ouput", {
  expect_equal(next_year(one_posix)$year, 117)
  expect_equal(next_month(one_posix)$mon, 2)
  expect_equal(next_day(one_posix)$mday, 18)
  expect_equal(next_hour(one_posix)$hour, 22)
  expect_equal(next_min(one_posix)$min, 20)
  expect_equal(next_sec(one_posix)$sec, 54)
})

test_that("set to 0/1 gives correct output", {
  expect_equal(month_to_1(one_posix)$mon, 0)
  expect_equal(day_to_1(one_posix)$mday, 1)
  expect_equal(hour_to_0(one_posix)$hour, 0)
  expect_equal(min_to_0(one_posix)$min, 0)
  expect_equal(sec_to_0(one_posix)$sec, 0)
})


test_that("quarter functions give correct output", {
  expect_equal(this_quarter_month(one_posix)$mon, 0)
  expect_equal(next_quarter_month(one_posix)$mon, 3)
})

test_that("week functions give correct output", {
  expect_equal(this_week(one_posix)$mday, 14)
  expect_equal(next_week(one_posix)$mday, 21)
})


context("end_val when start_val is specified")

test_that("shift_end_from_start gives correct output", {
  gsae_year <- get_start_and_end(posix_ct, convert_interval("year"))
  gsae_week <- get_start_and_end(posix_ct, convert_interval("week"))
  expect_equal(shift_end_from_start(gsae_year, as.Date("2016-02-01")),
               as.Date("2017-02-01"))
  expect_equal(shift_end_from_start(gsae_year, as.POSIXct("2016-02-01 00:04:01")), #nolint
               as.POSIXct("2017-02-01 00:04:01"))
  expect_equal(shift_end_from_start(gsae_week, as.Date("2015-12-25")),
               as.Date("2016-03-04"))
  expect_equal(shift_end_from_start(gsae_week, as.POSIXct("2015-12-25 00:04:01")), #nolint
               as.POSIXct("2016-03-04 00:04:01"))
})

context("assure_greater_than_max_x makes sure that end_val is greater than max_x")  #nolint

test_that("assure_greater_than_max_x works properly", {
  max_x_date <- as.Date("2016-07-21")
  max_x_posix <- as.POSIXct("2016-07-21 12:31:43")
  end_val_date <- as.Date("2016-07-14")
  end_val_posix <- as.POSIXct("2016-07-14 14:39:04")

  expect_equal( assure_greater_than_max_x(max_x_date, end_val_date, "month"),
                as.Date("2016-08-14"))
  expect_equal( assure_greater_than_max_x(max_x_date, end_val_posix, "month"),
                as.POSIXct("2016-08-14 14:39:04"))
  expect_equal( assure_greater_than_max_x(max_x_posix, end_val_posix, "month"),
                as.POSIXct("2016-08-14 14:39:04"))

  expect_equal( assure_greater_than_max_x(max_x_date, end_val_date, "day"),
                as.Date("2016-07-22"))
  expect_equal( assure_greater_than_max_x(max_x_date, end_val_posix, "day"),
                as.POSIXct("2016-07-21 14:39:04"))
  expect_equal( assure_greater_than_max_x(max_x_posix, end_val_posix, "day"),
                as.POSIXct("2016-07-21 14:39:04"))
})

test_that("span integration tests", {
  x <- coffee$time_stamp[3:4]
  sp <- function(interval) span(x, list(interval = interval, step = 1))
  expect_equal(sp("year"), span_date(2016, 2017))
  expect_equal(sp("quarter"), as.Date(c("2016-07-01", "2016-10-01")))
  expect_equal(sp("month"), span_date(201607, 201608))
  expect_equal(sp("week"), as.Date(c("2016-07-03", "2016-07-10", "2016-07-17")))
  expect_equal(sp("day"), span_date(20160709, 20160711))
})

context("span_around function")

test_that("span_around breaks on the wrong input", {
  expect_error(span_around(coffee, "hour"))
  expect_error(span_around(coffee$time_stamp, "hour"), NA)
  expect_error(span_around(coffee$time_stamp, "hour", start_shift = 12))
  expect_error(span_around(coffee$time_stamp, "hour", start_shift = "12 hour"), NA)
  expect_error(span_around(coffee$time_stamp, "hour", end_shift = 12))
  expect_error(span_around(coffee$time_stamp, "hour", end_shift = "12 hour"), NA)
})


test_that("span_around integration tests", {
  x <- as.POSIXct(c("2016-07-09 13:25:17", "2016-07-10 10:45:11"), tz = "CET")
  start_shift_one_hour <- span_around(x, "hour", start_shift = "1 hour")
  end_shift_one_hour <- span_around(x, "hour", end_shift = "1 hour")
  expect_error(span_around(1:10, "day"))
  expect_error(span_around(x, "day"), NA)
  expect_error(span_around(x, "2 days"), NA)
  expect_equal(span_around(x, "day"), span_date(20160709, 20160711))
  expect_equal(span_around(x, "hour"),
               span_time("20160709 13", "20160710 11", tz = "CET"))
  expect_equal(span_around(x, "min"),
               span_time("20160709 13", "20160710 1046", tz = "CET"))
  expect_equal(start_shift_one_hour[1],
               as.POSIXct("2016-07-09 12:00:00", tz = "CET"))
  expect_equal(start_shift_one_hour[length(start_shift_one_hour)],
               as.POSIXct("2016-07-10 12:00:00", tz = "CET"))
  expect_equal(end_shift_one_hour[1],
               as.POSIXct("2016-07-09 13:00:00", tz = "CET"))
  expect_equal(end_shift_one_hour[length(end_shift_one_hour)],
               as.POSIXct("2016-07-10 12:00:00", tz = "CET"))
  expect_equal(span_around(x, "day", start_shift = "1 day")[1], as.Date("2016-07-08"))
})

source('library.R')
dt_var  <- coffee$time_stamp
spanned <- span_date(20160708, 20160710)
full_spanned <- span_date(20160707, 20160712)

context("filtering when spanned is greater or smaller")

test_that("warning is thrown by warn_when_filtering", {
  expect_warning(warning_when_filtering(dt_var, full_spanned), NA)
  expect_warning(warning_when_filtering(dt_var, spanned),
                 "Dropping all values in the datetime var that are smaller than smallest spanned")
})

test_that("start_val_after_min_dt works in this context", {
  expect_equal(start_val_after_min_dt(min(spanned), dt_var), c(F, F, T, T))
  expect_equal(start_val_after_min_dt(min(full_spanned), dt_var), c(T, T, T, T))
})

test_that("end_val_before_max_dt works in this context", {
  expect_equal(end_val_before_max_dt(max(spanned), dt_var), c(T, T, T, F))
  expect_equal(end_val_before_max_dt(max(full_spanned), dt_var), c(T, T, T, T))
})

context("thicken_cust integration tests")

spanned_asym <- ymd_h(c("2016-07-07 08", "2016-07-09 11", "2016-07-10 23"),
                      tz = "UTC")
sw <- suppressWarnings

test_that("thicken_cust works properly", {
  # Manually setting the ts var in coffee, so test passes on systems with
  # a different time zone

  coffee$time_stamp <- as.POSIXct(c(
    "2016-07-07 09:11:21", "2016-07-07 09:46:48", "2016-07-09 13:25:17", "2016-07-10 10:45:11"
  ), tz = 'UTC')
  thicken_cust_1 <- thicken_cust(coffee, spanned_asym, "jos")$jos
  spanned_1 <- spanned_asym[c(1, 1, 2, 2)]
  expect_equal(thicken_cust_1, spanned_1)

  expect_warning(thicken_cust(coffee, spanned_asym[-1], "jos"),
                 "Dropping all values in the datetime var that are smaller than smallest spanned")

  thicken_cust_2 <- sw(thicken_cust(coffee, spanned_asym[-1], "jos")$jos)
  spanned_2 <- spanned_asym[c(2, 2)]
  expect_equal(thicken_cust_2, spanned_2)
})

context("thicken_cust drop argument")
test_that("the drop argument gives the desired result", {
  attr(coffee$time_stamp, "tzone") <- "UTC"
  hourly <- ymd_h(c("20160707 07",
                    "20160707 07",
                    "20160709 11",
                    "20160710 08"), tz = "UTC")
  coffee_hour <- coffee %>% mutate(time_stamp_hour = hourly)
  no_drop <- coffee_hour
  with_drop <- coffee_hour %>% select(-time_stamp)

  expect_equal(sw(thicken_cust(coffee,
                               spanned = hourly,
                               colname = "time_stamp_hour")), no_drop)
  expect_equal(sw(thicken_cust(coffee,
                               spanned = hourly,
                               colname = "time_stamp_hour",
                               drop = FALSE)), no_drop)
  expect_equal(sw(thicken_cust(coffee,
                               spanned = hourly,
                               colname = "time_stamp_hour",
                               drop = TRUE)), with_drop)
})


context("informative error for Year 2038 problem - thicken_cust")
x <- data.frame(dt = ymd_h("20381201 01", "20381202 01"))
sp <- as.Date(c("2038-12-01", "2038-12-02", "2038-12-04"))
expect_error(thicken_cust(x, sp, "day"),
             "thicken_cust does not work on POSIX data after 2038, due to Year 2038 problem. https://en.wikipedia.org/wiki/Year_2038_problem")

source("library.R")

#-----------------------------------------------------------------------------#
# get_date_variables

context("Test the get_date_variable function")

no_dt_var <- mtcars
one_day_var <- data.frame(x = ymd(20160201, 20160301), y = c(1, 2))
one_dt_var <- data.frame(x = ymd_h("20160201 02", "20160301 03"), y = c(1, 2))
two_dt_var <- data.frame(x = ymd_h("20160201 02", "20160301 03"), y = c(1, 2),
                         x2 = ymd(20160201, 20160301))

test_that("get_date_variable only works on the right data types", {
  expect_error(get_date_variables(one_day_var %>% as.matrix))
  expect_error(get_date_variables(one_day_var$x))
})

test_that("get_date_variable gives the correct output", {
  expect_equal(length(get_date_variables(no_dt_var)), 0)
  expect_equal(get_date_variables(one_day_var), "x")
  expect_equal(get_date_variables(one_dt_var), "x")
  expect_equal(get_date_variables(two_dt_var), c("x", "x2"))
})

#-----------------------------------------------------------------------------#

# enforce_time_zone
context("Test the enforce_time_zone")

test_that("enforce_timee zone works as expected", {

  a_ct <- ymd_h(c("20151201 03", "20160201 03"))
  b_ct <- ymd_hms(c("2015-01-01 00:00:00", "2016-01-01 00:00:00"))
  c_ct <- ymd_hms(c("2015-01-01 00:00:00", "2016-01-01 00:00:00"), tz = "CET")

  equal  <- enforce_time_zone(a_ct, b_ct)
  expect_warning({
    different <- enforce_time_zone(a_ct, c_ct)
  })

  expect_warning( enforce_time_zone(a_ct, c_ct))
  expect_equal( attr(equal, "tz"), "UTC")
  expect_equal( as.character(equal),
                c("2015-12-01 03:00:00", "2016-02-01 03:00:00"))
  expect_equal( attr(different, "tz"), "CET")
  expect_equal( as.character(different),
                c("2015-12-01 03:00:00", "2016-02-01 03:00:00"))
})

source("library.R")

x_df <- tibble(x = as.Date(c("2019-01-01", "2019-01-04", "2019-01-06")),
               y1 = c(3, 5, 6),
               y2 = c(11, 14, 14),
               y3 = rep(10, 3),
               y4 = c("A", "A", "B")) %>% pad()

context("Test the fill functions")

test_that("fill_ functions break with wrong input", {
  expect_error(x_df %>% as.list %>% fill_by_value(y1))
  expect_error(x_df %>% as.list %>% fill_by_function(y1))
  expect_error(x_df %>% as.list %>% fill_by_prevalent(y1))
  expect_error(x_df$y1 %>% as.list %>% fill_by_value(y1))
  expect_error(x_df$y1 %>% as.list %>% fill_by_function(y1))
  expect_error(x_df$y1 %>% as.list %>% fill_by_prevalent(y1))
  expect_error(x_df %>% fill_by_value(y1), NA)
  expect_error(x_df %>% fill_by_function(y1), NA)
  expect_error(x_df %>% fill_by_prevalent(y4), NA)
})

test_that("fill_by_value gives expected outcomes", {
  expect_equal( fill_by_value(x_df, y1)$y1[2], 0)
  expect_equal( fill_by_value(x_df, y1, y2)$y1[2], 0)
  expect_equal( fill_by_value(x_df, y1, y2)$y2[2], 0)
  expect_equal( fill_by_value(x_df, y1, value = 42)$y1[2], 42)
  expect_equal( fill_by_value(x_df, y1, y2, value = 42)$y1[2], 42)
  expect_equal( fill_by_value(x_df, y1, y2, value = 42)$y2[2], 42)
})

test_that("fill_by_function gives expected outcomes", {
  expect_error( fill_by_function(x_df, y1, fun = y2) )
  expect_equal( fill_by_function(x_df, y1)$y1 %>% median, 4 + 2 / 3)
  expect_equal( fill_by_function(x_df, y1, y2)$y1 %>% median, 4 + 2 / 3)
  expect_equal( fill_by_function(x_df, y1, y2)$y2 %>% median, 13)
  expect_equal( fill_by_function(x_df, y1, fun = median)$y1 %>% median, 5)
  expect_equal( fill_by_function(x_df, y1, y2, fun = median)$y1 %>% median, 5)
})

unname <- function(x) {
  names(x) <- NULL
  x
}

test_that("fill_by_prevalent gives expected outcomes", {
  expect_equal( unname(fill_by_prevalent(x_df, y4)$y4[2]), "A")
  expect_equal( unname(fill_by_prevalent(x_df, y3)$y3[2]), 10)
  expect_equal( unname(fill_by_prevalent(x_df, y3, y4)$y4[2]), "A")
  expect_equal( unname(fill_by_prevalent(x_df, y3, y4)$y3[2]), 10)
  expect_error( unname(fill_by_prevalent(x_df, y1)))
})

test_that("get_the_inds works properly", {
  x <- suppressWarnings(coffee %>% thicken('day') %>% group_by(time_stamp_day) %>%
    summarise(a = sum(amount)) %>% pad)
  x$b <- NA
  no_cols <- 2:3
  names(no_cols) <- c("a", "b")
  expect_equal(get_the_inds(x), no_cols)
  expect_equal(get_the_inds(x, a), 2)
  expect_equal(get_the_inds(x, a, b), 2:3)
})

source("library.R")
# standard inputs for class testing
days <- as.Date(c("2016-01-01", "2016-02-29"))
posix_ct <- as.POSIXct(c("2016-01-01 21:19:53", "2016-02-29 10:16:11"))
posix_lt <- as.POSIXlt(c("2016-01-01 21:19:53", "2016-02-29 10:16:11"))

context("get_interval fails on wrong input")

test_that("get_interval fails on non-datetime vectors", {
  expect_error(as.integer(days) %>% get_interval)
  expect_error(as.numeric(days) %>% get_interval)
  expect_error(as.character(days) %>% get_interval)
  expect_error(as.factor(days) %>% get_interval)
})

test_that("get_interval fails on data.frames", {
  expect_error(mtcars %>% get_interval)
})

test_that("get_interval does not fail on Date, POSIXct and POSIXlt", {
  expect_error(days %>% get_interval, NA)
  expect_error(posix_ct %>% get_interval, NA)
  expect_error(posix_lt %>% get_interval, NA)
})

context("datetime_char makes a full datetime character")

test_that("class is character", {
  expect_equal(days %>% datetime_char %>% class, "character")
  expect_equal(posix_ct %>% datetime_char %>% class, "character")
  expect_equal(posix_lt %>% datetime_char %>% class, "character")
})

test_that("datetime_char adds zeros to Date", {
  expect_equal(days %>% datetime_char,
               c("2016-01-01 00:00:00", "2016-02-29 00:00:00"))
})

test_that("datetime_char does not change POSIXt", {
  expect_equal(posix_ct %>% datetime_char,
               c("2016-01-01 21:19:53", "2016-02-29 10:16:11"))
  expect_equal(posix_lt %>% datetime_char,
               c("2016-01-01 21:19:53", "2016-02-29 10:16:11"))
})


context("lowest_differ returns the correct levels that differ")

test_that("lowest_differ return empty character whe x does not differ", {
  expect_equal( "2016-01-01 00:00:00" %>% lowest_differ, character(0) )
  expect_equal( c("2016-01-01 00:00:00", "2016-01-01 00:00:00") %>%
                  lowest_differ, character(0) )
})

test_that("get_interval breaks when x does not differ", {
  expect_error( "2016-01-01 00:00:00" %>% get_interval )
  expect_error( c("2016-01-01 00:00:00", "2016-01-01 00:00:00") %>%
                  get_interval)
})

test_that("lowest_differ returns the correct interval", {
  expect_equal( c("2016-01-01 00:00:00", "2017-01-01 00:00:00") %>%
                  lowest_differ, "year")
  expect_equal( c("2016-01-01 00:00:00", "2017-02-01 00:00:00") %>%
                  lowest_differ, "month")
  expect_equal( c("2016-01-01 00:00:00", "2017-02-03 00:00:00") %>%
                  lowest_differ, "day")
  expect_equal( c("2016-01-01 00:00:00", "2017-02-03 12:00:00") %>%
                  lowest_differ, "hour")
  expect_equal( c("2016-01-01 00:00:00", "2017-02-03 12:51:00") %>%
                  lowest_differ, "min")
  expect_equal( c("2016-01-01 00:00:00", "2017-02-03 12:51:23") %>%
                  lowest_differ, "sec")
})


context("is_ functions correctly identify quarter and week")

test_that("is_month_quarter gives correct result", {
  expect_true( is_month_quarter(
    c("2016-01-01 00:00:00", "2016-04-01 00:00:00")))
  expect_false( is_month_quarter(
    c("2016-01-01 00:00:00", "2016-03-01 00:00:00")))
  expect_true( is_month_quarter(
    c("2016-01-01 12:51:16", "2016-01-01 12:51:16")))
  expect_false( is_month_quarter(
    c("2016-01-01 12:51:16", "2016-03-01 12:51:16")))
})

test_that("is_day_week gives correct result", {
  expect_true( is_day_week(c("2016-01-01 00:00:00", "2016-01-08 00:00:00")))
  expect_false( is_day_week(c("2016-01-01 00:00:00", "2016-01-09 00:00:00")))
  expect_true( is_day_week(c("2016-01-01 12:51:16", "2016-01-08 12:51:16")))
  expect_false( is_day_week(c("2016-01-01 12:51:16", "2016-01-09 12:51:16")))
})

context("Testing the step suite, for after the interval is found")
test_that("get_difs helper function", {
  expect_equal(get_difs(c(1, 5, 6, 8)), c(4, 1, 2))
})

test_that("get_max_modulo_zero helper function", {
  expect_equal(get_max_modulo_zero(seq(0, length.out = 10, by = 2)), 2)
  expect_equal(get_max_modulo_zero(seq(0, length.out = 10, by = 3)), 3)
  expect_equal(get_max_modulo_zero(seq(0, length.out = 10, by = 11)), 11)
  expect_equal(get_max_modulo_zero(seq(0, length.out = 10, by = 51)), 51)
})

test_that("convert_month_to_number gives correct output", {
  mnths <- seq(ymd(20000101), length.out = 100, by = "month") %>%
    convert_month_to_number
  names(mnths) <- NULL
  expect_equal(mnths, 0:99)
})


test_that("step_of_year gives correct output", {
  x <- seq(ymd(20100101), length.out = 20, by = "year")
  expect_equal(step_of_year(x), 1)
  expect_equal( step_of_year(x[seq(1, 20, by = 2)]), 2)
  expect_equal( step_of_year(x[seq(1, 20, by = 3)]), 3)
  expect_equal( step_of_year(x[seq(1, 20, by = 5)]), 5)
  expect_equal( step_of_year(x[seq(1, 20, by = 9)]), 9)
})

test_that("step_of_quarter gives correct output", {
  x  <- seq(ymd(20100101), length.out = 20, by = "quarter")
  expect_equal( step_of_quarter(x), 1)
  expect_equal( step_of_quarter(x[seq(1, 20, by = 2)]), 2)
  expect_equal( step_of_quarter(x[seq(1, 20, by = 3)]), 3)
  expect_equal( step_of_quarter(x[seq(1, 20, by = 5)]), 5)
  expect_equal( step_of_quarter(x[seq(1, 20, by = 9)]), 9)
})

test_that("step_of_month gives correct output", {
  x  <- seq(ymd(20100101), length.out = 20, by = "month")
  expect_equal(step_of_month(x), 1)
  expect_equal( step_of_month(x[seq(1, 20, by = 2)]), 2)
  expect_equal( step_of_month(x[seq(1, 20, by = 3)]), 3)
  expect_equal( step_of_month(x[seq(1, 20, by = 5)]), 5)
  expect_equal( step_of_month(x[seq(1, 20, by = 9)]), 9)
})

test_that("step_of_difftime week gives correct output", {
  unit <- "week"
  x  <- seq(ymd(20160201), length.out = 20, by = unit)
  expect_equal(step_with_difftime(x, unit), 1)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 2)], unit), 2)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 3)], unit), 3)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 5)], unit), 5)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 9)], unit), 9)
})

test_that("step_with_difftime day gives correct output", {
  unit <- "day"
  x  <- seq(ymd(20160201), length.out = 20, by = unit)
  expect_equal(step_with_difftime(x, unit), 1)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 2)], unit), 2)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 3)], unit), 3)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 5)], unit), 5)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 9)], unit), 9)
})

test_that("step_with_difftime hour gives correct output", {
  unit <- "hour"
  x  <- seq(ymd_hms("20160201 000000" ), length.out = 20, by = unit)
  expect_equal(step_with_difftime(x, unit), 1)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 2)], unit), 2)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 3)], unit), 3)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 5)], unit), 5)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 9)], unit), 9)
})

test_that("step_with_difftime hour gives correct output", {
  unit <- "min"
  x  <- seq(ymd_hms("20160201 000000" ), length.out = 20, by = unit)
  expect_equal(step_with_difftime(x, unit), 1)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 2)], unit), 2)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 3)], unit), 3)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 5)], unit), 5)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 9)], unit), 9)
})

test_that("step_with_difftime hour gives correct output", {
  unit <- "sec"
  x  <- seq(ymd_hms("20160201 000000" ), length.out = 20, by = unit)
  expect_equal(step_with_difftime(x, unit), 1)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 2)], unit), 2)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 3)], unit), 3)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 5)], unit), 5)
  expect_equal( step_with_difftime(x[seq(1, 20, by = 9)], unit), 9)
})

context("test stop_on_NA")
test_that("stop_on_NA breaks the function when x has NAs", {
  x1 <- coffee$time_stamp
  x2 <- x1
  x2[2] <- NA
  expect_error(stop_on_NA(x1), NA)
  expect_error(stop_on_NA(x2), "interval cannot be determined when x contains NAs")
  expect_error(get_interval(x1), NA)
  expect_error(get_interval(x2), "interval cannot be determined when x contains NAs")
})

context("building blocks span_date")
sw <- suppressWarnings
test_that("check_to_len_out give right error", {
  jos <- 40
  expect_error(sw(check_to_len_out(jos, jos)), NA)
  expect_warning(check_to_len_out(jos, jos),
                 "both to and len_out are specified, len_out is ignored")
  expect_error(check_to_len_out(jos, NULL), NA)
  expect_error(check_to_len_out(NULL, jos), NA)
  expect_error(check_to_len_out(NULL, NULL),
               "either to or len_out must be specified")
})

test_that("check_valid_input_span errors on wrong datatype", {
  expect_error(check_valid_input_span(2011), NA)
  expect_error(check_valid_input_span("2011"), NA)
  expect_error(check_valid_input_span(TRUE),
               "from is not a character or numeric")
  expect_error(check_valid_input_span(as.Date("2011-01-01")),
               "from is not a character or numeric")
})

test_that("valid_numeric_dt errors on wrong format", {
  expect_error(valid_numeric_dt(2011.1, "jos"), "jos is not a valid integer")
  expect_error(valid_numeric_dt(2011.0, "jos"), NA)
  expect_error(valid_numeric_dt(2011L, "jos"), NA)
  expect_error(valid_numeric_dt(201, "jos"), "jos is not of a valid length")
  expect_error(valid_numeric_dt(2011), NA)
  expect_error(valid_numeric_dt(20110, "jos"), "jos is not of a valid length")
  expect_error(valid_numeric_dt(201101), NA)
  expect_error(valid_numeric_dt(2011010, "jos"), "jos is not of a valid length")
  expect_error(valid_numeric_dt(20110101), NA)
})

test_that("match_date_pattern only matches the right patterns", {
  expect_true(match_date_pattern("2016"))
  expect_true(match_date_pattern("201601"))
  expect_true(match_date_pattern("20160101"))
  expect_false(match_date_pattern("20160"))
  expect_false(match_date_pattern("2016010"))
  expect_false(match_date_pattern("2016010 0"))
})

test_that("match_date_time_pattern only matches the right patterns", {
  expect_true(match_date_time_pattern("20160101 01"))
  expect_true(match_date_time_pattern("20160101 0101"))
  expect_true(match_date_time_pattern("20160101 010101"))
  expect_false(match_date_time_pattern("20160101"))
  expect_false(match_date_time_pattern("20160101 0"))
  expect_false(match_date_time_pattern("2016010 010"))
  expect_false(match_date_time_pattern("2016010 01010"))
})

test_that("convert_to_date gives the correct outputs", {
  expect_equal(convert_to_date(2011), as.Date("2011-01-01"))
  expect_equal(convert_to_date(201102), as.Date("2011-02-01"))
  expect_equal(convert_to_date(20110203), as.Date("2011-02-03"))
  expect_equal(convert_to_date("2011"), as.Date("2011-01-01"))
  expect_equal(convert_to_date("201102"), as.Date("2011-02-01"))
  expect_equal(convert_to_date("20110203"), as.Date("2011-02-03"))
})

test_that("interval_from_short gives correct outputs", {
  expect_equal(interval_from_short(4), "year")
  expect_equal(interval_from_short(6), "month")
  expect_equal(interval_from_short(8), "day")
})

test_that("convert_to_datetime gives the correct outputs", {
  p <- function(x) as.POSIXct(x, tz = "UTC")
  expect_equal(convert_to_datetime(2011), p("2011-01-01"))
  expect_equal(convert_to_datetime(201102), p("2011-02-01"))
  expect_equal(convert_to_datetime(20110203), p("2011-02-03"))
  expect_equal(convert_to_datetime("2011"), p("2011-01-01"))
  expect_equal(convert_to_datetime("201102"), p("2011-02-01"))
  expect_equal(convert_to_datetime("20110203"), p("2011-02-03"))
  expect_equal(convert_to_datetime("20110101 01"), p("2011-01-01 01:00:00"))
  expect_equal(convert_to_datetime("201102"), p("2011-02-01"))
  expect_equal(convert_to_datetime("20110203"), p("2011-02-03"))
})

test_that("interval_from_long gives correct outputs", {
  expect_equal(interval_from_long(4), "year")
  expect_equal(interval_from_long(6), "month")
  expect_equal(interval_from_long(8), "day")
  expect_equal(interval_from_long(11), "hour")
  expect_equal(interval_from_long(13), "min")
  expect_equal(interval_from_long(15), "sec")
})

context("span_date integration tests")
test_that("span_date gives the desired outputs", {
  year_span <- seq.Date(as.Date("2011-01-01"), as.Date("2015-01-01"), by = "year")
  month_span <- seq.Date(as.Date("2011-01-01"), as.Date("2015-01-01"), by = "month")
  day_span <- seq.Date(as.Date("2011-01-01"), as.Date("2011-02-01"), by = "day")
  expect_equal(span_date(2011, 2015), year_span)
  expect_equal(span_date("2011", 2015), year_span)
  expect_equal(span_date("2011", "2015"), year_span)
  expect_equal(span_date(201101, 201501), month_span)
  expect_equal(span_date(2011, 2015, by = "month"), month_span)
  expect_equal(span_date(20110101, 20110201), day_span)
  expect_equal(span_date(20110101, 20150101, by = "month"), month_span)
  expect_equal(span_date(2011, len_out = 5), year_span)
  expect_equal(span_date(201101, len_out = 49), month_span)
  expect_equal(span_date(20110101, len_out = 32), day_span)
  expect_equal(span_date(20110101, len_out = 49, by = "month"), month_span)
})

context("span_time integration tests")
test_that("span_time gives the desired outputs", {
  p <- function(x) as.POSIXct(x, tz = "UTC")
  day_span <- seq.POSIXt(p("2011-01-01"), p("2011-02-01"), by = "day")
  hour_span <- seq.POSIXt(p("2011-01-01 00:00:00"), p("2011-01-01 23:00:00"), by = "hour")
  min_span <- seq.POSIXt(p("2011-01-01 00:00:00"), p("2011-01-01 00:25:00"), by = "min")
  sec_span <- seq.POSIXt(p("2011-01-01 00:00:00"),
                         p("2011-01-01 00:00:25"), by = "sec")

  expect_equal(span_time(20110101, 20110201), day_span)
  expect_equal(span_time("20110101", "20110201"), day_span)
  expect_equal(span_time("2011", "20110201"), day_span)
  expect_equal(span_time("20110101 00", "20110101 23"), hour_span)
  expect_equal(span_time("2011", "20110101 23"), hour_span)
  expect_equal(span_time("20110101 00", len_out = 24), hour_span)
  expect_equal(span_time("20110101 0000", "20110101 0025"), min_span)
  expect_equal(span_time("20110101 0000", len_out = 26), min_span)
  expect_equal(span_time("20110101 000000", "20110101 000025"), sec_span)
  expect_equal(span_time("20110101 000000", len_out = 26), sec_span)
})

context("Parts of center_interval")
test_that("int_to_secs gives the correct result", {
  sec_day <- 60 * 60 * 24
  expect_equal(int_to_secs(list(interval = "year", step = 2)),
               sec_day * 365 * 2)
  expect_equal(int_to_secs(list(interval = "quarter", step = 1)),
               sec_day * 365 / 4)
  expect_equal(int_to_secs(list(interval = "month", step = 3)),
               sec_day * 365 / 12 * 3)
  expect_equal(int_to_secs(list(interval = "week", step = 8)),
               sec_day * 7  * 8)
  expect_equal(int_to_secs(list(interval = "day", step = 1)),
               sec_day)
  expect_equal(int_to_secs(list(interval = "hour", step = 100)),
               360000)
  expect_equal(int_to_secs(list(interval = "min", step = 10)),
               600)
  expect_equal(int_to_secs(list(interval = "sec", step = 2)),
               2)
})

test_that("int_to_days gives the correct result", {
  expect_equal(int_to_days(list(interval = "year", step = 10)), 3650)
  expect_equal(int_to_days(list(interval = "month", step = 12)), 365)
  expect_equal(int_to_days(list(interval = "day", step = 2)), 2)
})

test_that("center_interval integration tests", {
  year_span  <- span_date(2016, len_out = 3)
  quarter_span <- span_date(201601, len_out = 3, by = "quarter")
  month_span <- span_date(201601, len_out = 3)
  week_span  <- span_date(2016, len_out = 3, by = "week")
  day_span   <- span_time(20160101, len_out = 3)
  hour_span  <- span_time("20160101 00", len_out = 3)
  min_span   <- span_time("20160101 0000", len_out = 3)
  sec_span    <- span_time("20160101 000000", len_out = 3, by = "5 sec")
  expect_equal(center_interval(year_span), year_span + 182.5)
  expect_equal(center_interval(year_span, "down"), year_span - 182.5)
  expect_equal(center_interval(year_span, interval = "10 days"), year_span + 5)
  expect_equal(center_interval(quarter_span), quarter_span + 365 / 8)
  expect_equal(center_interval(quarter_span, "down"), quarter_span - 365 / 8)
  expect_equal(center_interval(month_span), month_span + 365 / 24)
  expect_equal(center_interval(month_span, "down"), month_span - 365 / 24)
  expect_equal(center_interval(week_span), week_span + 7 / 2)
  expect_equal(center_interval(week_span, "down"), week_span - 7 / 2)
  expect_equal(center_interval(day_span), day_span + 3600 * 12)
  expect_equal(center_interval(day_span, "down"), day_span - 3600 * 12)
  expect_equal(center_interval(hour_span), hour_span + 1800)
  expect_equal(center_interval(hour_span, "down"), hour_span - 1800)
  expect_equal(center_interval(min_span), min_span + 30)
  expect_equal(center_interval(min_span, "down"), min_span - 30)
  expect_equal(center_interval(sec_span), sec_span + 2.5)
  expect_equal(center_interval(sec_span, "down"), sec_span - 2.5)
})


context("Parts of format_interval")

test_that("find_next_val helper function", {
  expect_equal(find_next_val(span_date(2016, 2018), 365),
               span_date(2017, 2019))
  expect_equal(find_next_val(span_time(2016, 2018), 365 * 24 * 3600),
               span_time(2017, 2019))
  expect_equal(find_next_val(span_date(201601, 201603), 31),
               span_date(201602, 201604))
  expect_equal(find_next_val(span_time(201601, 201603), 31 * 24 * 3600),
               span_time(201602, 201604))
  expect_equal(find_next_val(span_date(201601, len_out = 3, by = "week"), 7),
               span_date(20160108, len_out = 3, by = "week"))
  expect_equal(find_next_val(span_time(201601, len_out = 3, by = "week"), 7 * 24 * 3600),
               span_time(20160108, len_out = 3, by = "week"))
  non_eq_days <- span_date(20160101, 20160104)[c(1, 2, 4)]
  expect_equal(find_next_val(non_eq_days, 1),
               c(non_eq_days[c(2, 3)], as.Date("2016-01-05")))
})


test_that("get_units_to_last helper function", {
  gutl <- get_units_to_last
  expect_equal(gutl(span_date(2016, len_out = 2)), 365)
  expect_equal(gutl(span_time(2016, len_out = 2)), 365 * 24 * 3600)
  expect_equal(gutl(span_date(201601, len_out = 2)), 365 / 12)
  expect_equal(gutl(span_time(201601, len_out = 2)), round(30.41667 * 24 * 3600))
  expect_equal(gutl(span_date(20160101, len_out = 2)), 1)
  expect_equal(gutl(span_date(20160101, len_out = 5)[c(1, 3, 5)]), 2)
  expect_equal(gutl(span_time(20160101, len_out = 2)), 1 * 24 * 3600)
  expect_equal(gutl(span_time(20160101, len_out = 5)[c(1, 3, 5)]), 2 * 24 * 3600)
  expect_equal(gutl(span_time("20160101 00", len_out = 2)), 3600)
  expect_equal(gutl(span_time("20160101 00", len_out = 10)[c(2, 5, 8)]), 3600 * 3)
  expect_equal(gutl(span_time("20160101 00", len_out = 2)), 3600)
  expect_equal(gutl(span_time("20160101 00", len_out = 10)[c(2, 5, 8)]), 3600 * 3)
  expect_equal(gutl(span_time("20160101 0000", len_out = 2)), 60)
  expect_equal(gutl(span_time("20160101 000000", len_out = 10)[c(2, 5, 8)]), 3)
})


context("format_interval integration tests")
fse <- format_interval
x1 <- span_date(2016, 2017)
x2 <- span_time("20160101 00", len_out = 2, tz = "CET")
x3 <- lubridate::ymd(c(20160101, 20160103, 20160104))

test_that("format_interval throws errors", {
  expect_error(fse(1:10))
  expect_error(fse(c("20160101", "20160101")))
  expect_error(fse(span_date(2016, 2018)), NA)
  expect_error(fse(span_time(2016, 2018)), NA)
  expect_error(fse(rep(span_date(2016, 2017)), 2))
  expect_error(fse(lubridate::ymd(20160101)))
})

test_that("format_interval formatting", {
  expect_equal(fse(x1), c("2016-01-01 2017-01-01", "2017-01-01 2018-01-01"))
  expect_equal(fse(x1, start_format = "%y", sep = "-"), c("16-17", "17-18"))
  expect_equal(fse(x2, start_format = "%F %H", end_format = "%H", sep = "-"),
               c("2016-01-01 00-01", "2016-01-01 01-02"))
})

test_that("format_interval end _offset works", {
  expect_equal(fse(x1, end_offset = 1),
               c("2016-01-01 2016-12-31", "2017-01-01 2017-12-31"))
  expect_equal(fse(x2, start_format = "%F %T", end_offset = 60),
               c("2016-01-01 00:00:00 2016-01-01 00:59:00",
                 "2016-01-01 01:00:00 2016-01-01 01:59:00"))
})

test_that("format_interval works for non symmetrics", {
  expect_equal(fse(x3),
               c("2016-01-01 2016-01-03", "2016-01-03 2016-01-04", "2016-01-04 2016-01-05"))
  expect_equal(fse(x3, units_to_last = 2),
               c("2016-01-01 2016-01-03", "2016-01-03 2016-01-04", "2016-01-04 2016-01-06"))
})

test_that("format_interval works with different timezones", {
  dt <- span_time("20170801 00", by = "3 hour", len_out = 3,
                  tz = "EST")
  expect_equal(fse(dt, start_format = "%H"),
               c("00 03", "03 06", "06 09"))
})

source("library.R")

x_year  <- as.Date(c("2015-01-01", "2016-01-01", "2018-01-01"))

x_month <- seq(as.Date("2015-01-01"), as.Date("2015-06-01"),
               by = "month")[c(1, 3, 4, 6)]

x_day   <- seq(as.Date("2015-01-01"), as.Date("2015-02-01"),
               by = "day") %>% sample(15) %>%
  c(as.Date("2015-01-01"), as.Date("2015-02-01")) %>% unique

x_hour  <- seq(
  as.POSIXct("2015-01-01 01:00:00"),
  as.POSIXct("2015-01-03 01:00:00"),
  by = "hour"
)[c(1, 25, 49)]

x_min   <- seq(lubridate::ymd_hms("2015-01-01 00:00:00"),
               lubridate::ymd_hms("2015-01-01 00:59:00"), by = "min") %>%
  sample(15) %>%
  c(lubridate::ymd_hm("2015-01-01 00:00"),
    lubridate::ymd_hm("2015-01-01 00:59")) %>%
  unique

sw <- suppressWarnings

context("Test the pad function")

test_that("Correct error handling", {
  expect_error(pad(x_month %>% as.character))
  expect_error(pad(x_month %>% as.numeric))
  expect_error(pad(mtcars))
})


test_that("Pad works properly on data.table and tbl", {
  expect_equal(class(pad(data.table::data.table(x_year, 1)))[1], "data.table")
  expect_equal(class(pad(dplyr::tibble(x_year, 1)))[1], "tbl_df")
})

context("pad gives correct output with one datetime value")

test_that('gives warning and same result when start_val and end_val are NULL', {
  x <- data.frame(tm = ymd(20160102))
  expect_warning(pad(x))
  suppressWarnings(expect_equal(pad(x), x))
})

test_that("break_above prevents large output", {
  large_df <- data.frame(x = ymd_h("2000-01-01 01", "2004-01-01 00"), y = 1:2)
  large_df_grp <- rbind(large_df, large_df)
  large_df_grp$grp <-  rep(letters[1:2], each = 2)
  expect_error( pad(large_df, interval = "min") )
  expect_error( pad(large_df_grp, interval = "min", group = "grp") )
  expect_error( nrow(pad(large_df, interval = "hour", break_above = 0.035)))
  expect_error( nrow(pad(large_df_grp, interval = "hour", break_above = 0.07, group = "grp")))
  expect_equal( nrow(pad(large_df, interval = "hour", break_above = 0.0351)), 35064)
  expect_equal( nrow(pad(large_df_grp, interval = "hour", group = "grp",
                         break_above = 0.0702)), 70128)

})

test_that('gives correct output when end_val and/or start_val are specified, date', {
  x <- data.frame(tm = ymd(20160102))
  expect_equal(pad(x, start_val = ymd(20160101))$tm, c(ymd(20160101), x$tm))
  expect_equal(pad(x, end_val = ymd(20160104), interval = "day")$tm,
               c(x$tm, ymd(20160103), ymd(20160104)))
  expect_equal(pad(x, start_val = ymd(20160101), end_val = ymd(20160104))$tm,
               seq(ymd(20160101), by = 'day', length.out = 4))
})

test_that("pad gives informative error when start_val or end_val is of wrong class", {
  x <- data.frame(tm = ymd(20160102, 20160103))
  expect_error(pad(x, start_val = "20160101"),
               "start_val should be of class Date, POSIXlt, or POSIXct")
  expect_error(pad(x, end_val = "20160101"),
               "end_val should be of class Date, POSIXlt, or POSIXct")
})

test_that('gives correct output when end_val and/or start_val are specified, posix', {
  x <- data.frame(tm = ymd_h('20160102 16'))
  s_val <- ymd_h('20160101 16')
  e_val <- ymd_h('20160104 16')
  compare <- seq(s_val, by = 'day', length.out = 4)
  expect_equal(pad(x, start_val = s_val)$tm, compare[1:2])
  expect_equal(pad(x, end_val = e_val, interval = "day")$tm, compare[2:4])
  expect_equal(pad(x, start_val = s_val, end_val = e_val)$tm, compare)
})

test_that("gives correct output when start or end with datetime range", {
  x <- data.frame(dt = ymd(20170101, 20180101), x = 1:2)
  expect_equal(pad(x, start_val = ymd(20170201))$dt,
               seq(ymd(20170201), ymd(20180101), by = "month"))
  expect_equal(pad(x, end_val = ymd(20170601))$dt,
               seq(ymd(20170101), ymd(20170601), by = "month"))

  x_grp <- data.frame(dt = ymd(20170101, 20170601, 20170201, 20170501),
                      id = c(1, 1, 2, 2),
                      x  = 1:4)
  expect_equal(pad(x_grp, group = "id", start_val = ymd(20170401))$dt,
               ymd(20170401, 20170501, 20170601, 20170401, 20170501))
  expect_equal(pad(x_grp, group = "id", end_val = ymd(20170301))$dt,
               ymd(20170101, 20170201, 20170301, 20170201, 20170301))
})

context("pad_single and pad_multiple, addtions to padr")

test_that("pad gives correct output, with no groups", {
  mnths <- seq(ymd(20160101), length.out = 6, by = 'month')
  x <- data.frame(m = mnths[c(2, 4, 5)])
  expect_equal( pad(x, "month")$m, mnths[2:5])
  expect_equal( pad(x, start_val = mnths[1])$m, mnths[1:5])
  expect_equal( pad(x, end_val = mnths[6])$m, mnths[2:6])
})


test_that("pad_multiple pads correctly with one group var", {
  mnths <- seq(ymd(20160101), length.out = 6, by = 'month')
  x <- data.frame(m = rep( mnths[c(2, 4, 5)], 2), g = letters[c(1, 1, 1, 2, 2, 2)])
  expect_equal( pad(x, group = 'g', interval = "month")$m, rep(mnths[2:5], 2) )
  expect_equal( sw(pad(x, group = 'g', start_val = mnths[1]))$m, rep(mnths[1:5], 2) )
  expect_equal( sw(pad(x, group = 'g', end_val = mnths[6]))$m, rep(mnths[2:6], 2) )
})

test_that("pad pads correctly with two group vars", {
  mnths <- seq(ymd(20160101), length.out = 6, by = 'month')
  x <- data.frame(m  = rep( mnths[c(2, 4, 5)], 4),
                  g1 = letters[rep(1:2, each = 6)],
                  g2 = letters[rep(5:8, each = 3)])
  expect_equal( pad(x, group = c('g1', 'g2'), interval = "months")$m, rep(mnths[2:5], 4) )
  expect_equal( sw(pad(x, group = c('g1', 'g2'), start_val = mnths[1]))$m,
                   rep(mnths[1:5], 4) )
  expect_equal( sw(pad(x, group = c('g1', 'g2'), end_val = mnths[6]))$m,
                   rep(mnths[2:6], 4) )
})

test_that("dplyr grouping yields correct results", {
  mnths <- seq(ymd(20160101), length.out = 5, by = 'month')
  x_complete <- data.frame(m  = rep( mnths, 4),
                           g1 = letters[rep(1:2, each = 10)],
                           g2 = letters[rep(5:8, each = 5)],
                           y  = 1)
  x <- x_complete[-c(3, 8, 13, 18), ]
  x_one_group <- x_complete[-c(3, 13), ] %>%
    arrange(g1, m)
  x_one_group[c(5, 14), c(3, 4)] <- NA
  x_complete[c(3, 8, 13, 18), 4] <- NA
  expect_equal(x_one_group,
               pad(dplyr::group_by(x, g1)) %>% as.data.frame )
  expect_equal(x_complete,
               pad(dplyr::group_by(x, g1, g2)) %>% as.data.frame)
  expect_warning(pad(group_by(x, g2), group = "g1"))
  expect_equal( sw(pad(group_by(x, g2), group = "g1")) %>% as.data.frame,
                x_one_group)
  expect_equal( pad(group_by(x, g1)) %>% groups %>% as.character, "g1")
})

test_that("grouping works with irregular colnames", {
  x <- dplyr::tibble(`group col`     = rep(letters[1:2], each = 3),
                     date     = rep(as.Date(c("2020-10-01", "2020-10-02", "2020-10-03")), 2),
                     value       = c(1, NA, 2, 3, NA, 4))
  x_to_pad <- x[c(1,3,4,6), ]
  expect_equal(pad(x_to_pad, group = "group col", interval = "day"), x)
  expect_equal(x_to_pad %>% dplyr::group_by(`group col`) %>%
                 pad(interval = "day") %>% dplyr::ungroup(), x)
})

test_that("datetime variable in the grouping throws an error", {
  coffee$grp <- c(1, 2, 1, 2)
  expect_error(pad(coffee, group = "time_stamp"))
  expect_error(coffee %>% group_by(time_stamp) %>% pad)
  expect_error(pad(coffee, group = c("time_stamp", 'grp')))
  expect_error(coffee %>% group_by(time_stamp, grp) %>% pad)
})

test_that("the by arguments works, both in pad and pad_single", {
  one_var <- data.frame(x_year = x_year, val = 1)
  two_var <- one_var; two_var$x_year2 <- two_var$x_year
  one_var_grps <- rbind(one_var, one_var)
  one_var_grps$grp <- rep(letters[1:2], each = 3)
  two_var_grps <- rbind(two_var, two_var)
  two_var_grps$grp <- rep(letters[1:2], each = 3)
  check_val <- seq( ymd(20150101), length.out = 4, by = 'year')

  expect_equal( pad(one_var, by = "x_year", interval = "year")$x_year, check_val)
  expect_equal( pad(one_var_grps, by = "x_year", group = 'grp',  interval = "year")$x_year,
                rep(check_val, 2) )
  expect_equal( pad(two_var, "year", by = "x_year")$x_year, check_val)
  expect_equal( pad(two_var_grps, "year", by = "x_year", group = 'grp')$x_year,
                rep(check_val, 2) )
})

test_that("pad works correclty when start is after or end is before range", {
  x_grp <- data.frame(x   = as.Date(c("2017-04-01", "2017-07-01",
                                      "2017-09-01", "2017-11-01")),
                      grp = rep(letters[1:2], each = 2),
                      y   = 1:4)
  x_sing_1 <- x_grp[1:2, ]
  x_sing_2 <- x_grp[3:4, ]
  expect_error(pad(x_sing_1, start_val = as.Date("2017-08-01")),
               "start value is larger than the end value.")
  expect_error(pad(x_sing_1, end_val = as.Date("2017-03-01")),
               "start value is larger than the end value.")
  expect_warning(pad(x_grp, group = "grp", start_val = as.Date("2017-08-01")))
  expect_warning(pad(x_grp, group = "grp", end_val = as.Date("2017-08-01")))

  x_sing_1_pad <- pad(x_sing_1, group = "grp", interval = "month")
  x_start_val <- sw(pad(x_grp, group = "grp", end_val = as.Date("2017-07-01"),
                        interval = "month"))
  expect_equal(x_sing_1_pad, x_start_val)

  x_sing_2_pad <- pad(x_sing_2, group = "grp", interval = "month")
  x_end_val <- sw(pad(x_grp, group = "grp", start_val = as.Date("2017-09-01"),
                      interval = "month"))
  expect_equal(x_sing_2_pad, x_end_val)
})

context("pad integration tests")
test_that("Pad gives correct results", {
  expect_equal(pad(data.frame(x_year, 1), "year") %>% nrow, 4)
  expect_equal(pad(data.frame(x_year, 1), "year", end_val = as.Date("2021-01-01")) %>%
                 nrow, 7)
  expect_equal(pad(data.frame(x_year, 1), "year", start_val = as.Date("2012-01-01")) %>%
                 nrow, 7)
  expect_equal(pad(data.frame(x_year, 1), interval = "month") %>% nrow, 37)
  expect_equal(pad(data.frame(x_month, 1)) %>% nrow, 6)
  expect_equal(suppressWarnings(pad(data.frame(x_day, 1))) %>% nrow, 32)
  expect_equal(pad(data.frame(x_hour, 1)) %>% nrow, 3)
  expect_equal(pad(data.frame(x_hour, 1), interval = "hour") %>% nrow, 49)
  expect_equal(suppressWarnings(pad(data.frame(x_min, 1))) %>% nrow, 60)
})

context("pad shows message about interval")
test_that("gives message when interval is NULL", {
  # Manually setting the ts var in coffee, so test passes on systems with
  # a different time zone
  coffee$time_stamp <- as.POSIXct(c(
    "2016-07-07 09:11:21", "2016-07-07 09:46:48", "2016-07-09 13:25:17", "2016-07-10 10:45:11"
  ))
  x1 <- coffee %>% thicken("hour") %>% select(-time_stamp)
  x2 <- coffee %>% thicken("6 hour") %>% select(-time_stamp)
  expect_message(pad(x1), "pad applied on the interval: hour\n")
  expect_message(pad(x2), "pad applied on the interval: 18 hour\n")
})


test_that("gives no message when interval is not NULL", {
  x1 <- coffee %>% thicken("hour") %>% select(-time_stamp)
  expect_message(pad(x1, interval = "hour"), NA)
})

test_that("pad works when datetime variable name is irregular", {
 irreg <- data.frame(x = span_date(2016, 2018)[c(1, 3)], val = 1:2)
 colnames(irreg)[1] <- 42
 expect_error(pad(irreg, interval = "year"), NA)
 colnames(irreg)[1] <- "test_/_hello"
 expect_error(pad(irreg, interval = "year"), NA)
})


context("pad and thickens with a NA values in the datetime variable")
test_that("pad works properly on with NA values", {
  coffee_na <- coffee %>% thicken("day", "d") %>% count(d) %>% pad %>%
    fill_by_value()
  coffee_na[3, 1] <- NA
  coffee_na_padded <- suppressWarnings(coffee_na %>% pad())
  expect_error(suppressWarnings(coffee_na %>% pad()), NA)
  expect_warning(coffee_na %>% pad(),
"There are NA values in the column d. The records with NA values are returned
in the final rows of the dataframe.")
  expect_equal(coffee_na_padded %>% nrow(), 5)
  expect_equal(coffee_na_padded %>% filter(is.na(d)) %>% nrow, 1)
  expect_equal(coffee_na_padded$d[5] %>% as.character(), NA_character_)
})


context("pad deals with daylight savings time well when dt_var is POSIXt")
test_that("pad work well with day and week", {
  cross_dst <- data.frame(day = as.POSIXct(c('2020-03-08', '2020-03-22'),
                                           'America/Chicago'))
  expect_error(pad(cross_dst, interval = 'day'), NA)
  expect_error(pad(cross_dst, interval = 'week'), NA)
})

test_that("The use of DSTday for the interval throws a meaningful error", {
  cross_dst <- data.frame(day = as.POSIXct(c('2020-03-08', '2020-03-22'),
                                           'America/Chicago'))
  expect_error(pad(cross_dst, 'DSTday'),
               "DSTday does not work for interval, please use 'day' instead", fixed = TRUE)
  expect_error(pad(cross_dst, '2 DSTday'),
               "DSTday does not work for interval, please use 'day' instead", fixed = TRUE)
})

source("library.R")

x <- span_date(20170104, len_out = 7, by = "day")

context("closest_weekday function")
test_that("closest_weekday down", {
  expect_equal(closest_weekday(x), ymd(20170102))
  expect_equal(closest_weekday(x, 3), ymd(20170104))
  expect_equal(closest_weekday(x, 5), ymd(20161230))
})

test_that("closest_weekday up", {
  expect_equal(closest_weekday(x, direction = "up"), ymd(20170109))
  expect_equal(closest_weekday(x, 3, direction = "up"), ymd(20170104))
  expect_equal(closest_weekday(x, 5, direction = "up"), ymd(20170106))
})

source("library.R")

df <- data.frame(y = c(2006, 2008, 2012, 2007, 2008, 2011),
                 g = rep(LETTERS[1:2], each = 3),
                 v = sample(1:10, 6))

df2 <- data.frame(y = c(2006, 2010, 2006, 2010),
                  g = rep(LETTERS[1:2], each = 2),
                  v = sample(1:10, 4))

context("Testing the pad_int")

test_that("pad_int throws warnings with incorrect input", {
  df$year <- ymd(paste(df$y, '0101', sep = ''))
  expect_error(pad_int(df, 'g'))
  expect_error(pad_int(df,  'year'))
  expect_error(pad_int(df$y,  'year'))
})

test_that("pad_int without groups", {
  df_single <- df %>% filter(g == 'A')
  expect_equal( pad_int(df_single, 'y') %>% nrow, 7)
  expect_equal( pad_int(df_single, 'y', start_val = 2004) %>% nrow, 9)
  expect_equal( pad_int(df_single, 'y', start_val = 2007) %>% nrow, 6)
  expect_equal( pad_int(df_single, 'y', end_val = 2014) %>% nrow, 9)
  expect_equal( pad_int(df_single, 'y', end_val = 2011) %>% nrow, 6)
  expect_equal( pad_int(df_single, 'y', step = 2) %>% nrow, 4)
  expect_error( pad_int(df_single, 'y', step = 3))
})

test_that("pad_int with groups", {
  expect_equal( pad_int(df, 'y', group = 'g') %>% nrow, 12)
  expect_equal( pad_int(df, 'y', group = 'g', start_val = 2004) %>% nrow, 17)
  expect_equal( pad_int(df, 'y', group = 'g', start_val = 2007) %>% nrow, 11)
  expect_equal( pad_int(df, 'y', group = 'g', end_val = 2014) %>% nrow, 17)
  expect_equal( pad_int(df, 'y', group = 'g', end_val = 2011) %>% nrow, 11)
  expect_equal( pad_int(df2, 'y', group = 'g', step = 2) %>% nrow, 6)
  expect_error( pad_int(df2, 'y', group = 'g', step = 3) )
})

test_that("pad_int works on both tbl and data.table", {
  df_tbl <- dplyr::as_tibble(df)
  df_dt  <- data.table::as.data.table(df)
  expect_error(pad_int(df_tbl, "y"), NA)
  expect_error(pad_int(df_dt, "y"), NA)
  expect_true(inherits(pad_int(df_tbl, "y"), "tbl"))
  expect_true(inherits(pad_int(df_dt, "y"), "data.table"))
})

context("Helper functions for pad_cust")

test_that("check_dt_in_spanned", {
  sp <- span_date(20170101, len_out = 3)
  expect_error(check_dt_in_spanned(as.Date("2017-01-01"), sp), NA)
  expect_error(check_dt_in_spanned(span_date(20170101, len_out = 2), sp), NA)
  expect_error(check_dt_in_spanned(as.Date("2017-01-04"), sp),
               "Observations in the datetime variable, that are not in spanned.
  Either run thicken_cust in combination with aggregation first, or rerun this function
  with drop_last_spanned = FALSE.")
})


test_that("check_same_data_type", {
  date <- span_date(20170101, len_out = 3)
  time <- span_time(20170101, len_out = 3)
  expect_error(check_same_data_type(date, date), NA)
  expect_error(check_same_data_type(time, time), NA)
  expect_error(check_same_data_type(time, date),
               "spanned and the datetime variables of different data types")
  expect_error(check_same_data_type(date, time),
               "spanned and the datetime variables of different data types")
})

test_that("pad_cust drop last argument", {
  x <- data.frame(a = span_date(20160101, len_out = 2, by = "day"), b = 1)
  span <- span_date(20160101, len_out = 3, by = "day")
  expect_equal(x, pad_cust(x, span, drop_last_spanned = TRUE))
  expect_equal(pad_cust(x, span, drop_last_spanned = FALSE) %>% nrow(), 3)
  expect_equal(pad_cust(x, span, drop_last_spanned = FALSE)$a, span)
})

test_that("pad_cust_group_span", {
  sp  <- span_date(20170101, len_out = 4)[c(1, 3, 4)]

  one_group_padded <- tibble(date = rep(sp, 2),
                             grp  = rep(c("a", "b"), each = 3),
                             val  = c(1, NA, 1, 1, NA, 1))

  one_group <- one_group_padded[c(1, 3, 4, 6), ]

  og_no_group <- bind_rows(one_group[1:2, ],
                           tibble(date = ymd(20170103), grp = NA, val = NA),
                           one_group[3:4, ]) %>%
    arrange(date)

  two_group_padded <- tibble(date = rep(sp, 4),
                             grp1 = rep(c("a", "b"), each = 6),
                             grp2 = rep(c("d", "e"), 6),
                             val  = c(1, NA, 1, 1, NA, 1, 1, NA, 1, 1, NA, 1)) %>%
    arrange(grp1, grp2, date)

  two_group <- two_group_padded[-c(2, 5, 8, 11), ]

  tg_one_group <- two_group_padded[-c(5, 11), ]
  tg_one_group[c(2, 7), "grp2"] <- NA
  tg_one_group <- arrange(tg_one_group, grp1, date)
  tg_no_group <- tg_one_group[-8, ]
  tg_no_group[3, "grp1"] <- NA
  tg_no_group <- arrange(tg_no_group, date)

  expect_equal(
    pad_cust(one_group, spanned = sp, drop_last_spanned = FALSE),
    og_no_group)

  expect_equal(
    pad_cust(one_group, spanned = sp, group = "grp", drop_last_spanned = FALSE),
    one_group_padded
  )

  expect_equal(
    one_group %>% group_by(grp) %>% pad_cust(spanned = sp, drop_last_spanned = FALSE),
    one_group_padded %>% group_by(grp)
  )

  expect_equal(
    pad_cust(two_group, span = sp, drop_last_spanned = FALSE),
    tg_no_group
  )

  expect_equal(
    pad_cust(two_group, span = sp, group = "grp1", drop_last_spanned = FALSE),
    tg_one_group
  )

  expect_equal(
    two_group %>% group_by(grp1) %>% pad_cust(span = sp, drop_last_spanned = FALSE),
    tg_one_group %>% group_by(grp1)
  )

  expect_equal(
    pad_cust(two_group, span = sp, group = c("grp1", "grp2"), drop_last_spanned = FALSE),
    two_group_padded
  )

  expect_equal(
    two_group %>% group_by(grp1, grp2) %>% pad_cust(span = sp, drop_last_spanned = FALSE),
    two_group_padded %>% group_by(grp1, grp2)
  )
})

context("round_down_core and round_up_core cpp functions")

a <- c(2, 5, 6, 9)
b <- c(1, 5, 9, 13)

test_that("round_down_core will assign ties to current", {
  expect_equal(round_down_core(a, b),
               c(1, 5, 5, 9))
})

test_that("round_down_core will assign ties to previous", {
  expect_equal(round_down_core_prev(a, b),
               c(1, 1, 5, 5))
})

test_that("round_up_core will assign ties to next", {
  expect_equal(round_up_core(a, b),
               c(5, 9, 9, 13))
})

test_that("round_up_core will assign ties to current", {
  expect_equal(round_up_core_prev(a, b),
               c(5, 5, 9, 9))
})

---
title: "Introduction to `padr`"
author: "Edwin Thoen"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Introduction to `padr`}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

When getting time series data ready for analysis, you might be confronted with the following two challenges:

* The observations are recorded on too low a level, e.g. time recorded to the second, where your analysis is on a daily level.
* There are no records for the time points where observations were absent.

`padr` aims to make light work of preparing time series data by offering the two main functions `thicken` and `pad`. A small example before we get into detail. Say I want to make a line plot of my daily expenses at the coffee place. The data for a few days might look like.

```{r, fig.width=7}
library(padr)
coffee
```

Using `padr` in combination with `dplyr` this plot is made in the following way:

```{r, fig.width=7, message = FALSE}
library(ggplot2); library(dplyr)

coffee %>% 
  thicken('day') %>% 
  group_by(time_stamp_day) %>%
  summarise(day_amount = sum(amount)) %>% 
  pad() %>% 
  fill_by_value() %>% 
  ggplot(aes(time_stamp_day, day_amount)) + geom_line()
```

Quite some stuff going on here, let's go through the functions one by one to see what they do.

### thicken

`thicken` adds a column to a data frame that is of a higher *interval* than that of the original datetime variable. The interval in the `padr` context is the heartbeat of the data, the recurrence of the observations.[^1] The original variable "time_stamp" had the interval *second*, the added variable was of interval *day*.

```{r}
coffee2 <- coffee %>% thicken('day')
coffee2$time_stamp %>% get_interval()
coffee2$time_stamp_day %>% get_interval()
```

`thicken` does figure out some stuff for you. First it finds the datetime variable in your data frame (given there is only one). Next it will determine the interval of this variable, which is one of the following: year, quarter, month, week, day, hour, minute, or second. Besides the interval, it also finds the interval unit (E.g. 5 minutes, 10 days, 2 months). Finally, it adds a variable to the data frame that is of a higher interval than the interval of the original datetime variable. The user can then use this variable to aggregate to the higher level, for instance using `dplyr`'s `group_by` and `summarise`. Besides the interval, the user can also specify the units. When no unit is specified, a single unit is applied.

```{r}
to_thicken <- data.frame(day_var = as.Date(c('2016-08-12', '2016-08-13', 
                                              '2016-08-26', '2016-08-29')))
to_thicken %>% thicken(interval = "week")
to_thicken %>% thicken(interval = "4 days")
```

We see different default behavior for the different *intervals*. Week intervals start on Sundays, day intervals start on the first day found in the datetime variable. In many situations the user will be content with `thicken`'s defaults. However, you can specify the `start_val` as an offset if you would like to start the returned interval on a different day or datetime.

We use the emergency data set for further illustration. It contains 120,450 emergency calls in Montgomery County, PA, between 2015-12-10 and 2016-10-17. It has four columns that contain information about the location of the emergency, a title field indicating the type of the emergency, and a time stamp. The data set was created from a Google Api, thanks to Mike Chirico for maintaining this set. 

```{r}
head(emergency)
```

Say we are interested in the number of overdoses that occurred daily. However, we don't want incidents during the same night to be split into two days, what would have happened when we use the default behavior. Rather, we reset the count at 8 am, grouping all nightly cases to the same day. The interval is still *day*, but each new day starts at 8 am instead of midnight. The `start_val` serves as an offset. 

```{r}
emergency %>% filter(title == 'EMS: OVERDOSE') %>% 
  thicken('day', 
          start_val = as.POSIXct('2015-12-11 08:00:00', tz = 'EST'),
          colname = 'daystart') %>% 
  group_by(daystart) %>% 
  summarise(nr_od = n()) %>% 
  head()
```

Note also that we specified the column name of the added column. If we don't, `thicken` takes the column name of the original datetime variable and appends it with the interval of the thickened variable, separated by an underscore. 

Two final points on intervals before we are going to `pad`:

* It is about the recurrence pattern, not the moment in time where the observations toke place. (A yearly observation can take place each year at June 23rd at 9.15 pm).
* It doesn't require an observation at each and every time point where there could be one. It is the highest recurrence level in the hierarchy that can explain all the observations.

### pad

The second workhorse of `padr` is `pad`. It does date padding:

```{r}
account <- data.frame(day     = as.Date(c('2016-10-21', '2016-10-23', '2016-10-26')),
                      balance = c(304.46, 414.76, 378.98))
account %>% pad()
```

The account dataframe has three observations on different days. Like `thicken`, the `pad` function figures out what the datetime variable in the data frame is, and then assesses its interval. Next it notices that within the interval, *day* in this case, rows are lacking between the first and last observation. It inserts a row in the data frame for every time point that is lacking from the data set. All non-datetime values will get missing values at the padded rows. 

It is up to the user what to do with the missing records. In the case of the balance of an account we want to carry the last observation forward. It needs `tidyr::fill` to arrive at the tidy data set.

```{r}
account %>% pad() %>% tidyr::fill(balance)
```

Also `pad` allows for deviations from its default behavior. By default it pads all observations between the first and the last observation, but you can use `start_val` and `end_val` to deviate from this. You can also specify a lower interval than the one of the variable, using `pad` as the inverse of `thicken`.

```{r}
account %>% pad('hour', start_val = as.POSIXct('2016-10-20 22:00:00')) %>% head()
```

### Grouping

When you want to `thicken` and `pad` within groups there are two options. Either you group the data with `dplyr::group_by()` before applying them, or you specify the `group` argument in `pad`. Note that `thicken` does not have a grouping argument, because thickening with or without grouping would give the same result. However, `thicken` does preserve `dplyr` grouping.

```{r}
grouping_df <- data.frame(
  group = rep(c("A", "B"), c(3, 3)),
  date  = as.Date(c("2017-10-02", "2017-10-04", "2017-10-06", "2017-10-01", 
                    "2017-10-03", "2017-10-04")),
  value = rep(2, 6)
)
grouping_df %>% 
  pad(group = "group")
```

Note in the above that each group is padded from its own start to its end. If you want the starts and ends of each groups to be similar use the `start_val` and `end_val` arguments. Note further that the interval on which to pad is assessed over the groups. It is assumed that the user wants to bring all observations to the same interval. If you do want each group to have its own interval, use `dplyr::do` in the following way.

```{r}
grouping_df %>% 
  group_by(group) %>% 
  do(pad(.))
```

### fill functions
We already saw `tidyr::fill` coming in handy for the filling of missing values after padding. `padr` comes with three more fill functions: `fill_by_value`, `fill_by_function`, and `fill_by_prevalent`. They fill missing values by respectively a single value, a function of the nonmissing values, and the most prevalent value among the nonmissing values.

```{r}
counts <- data.frame(x = as.Date(c('2016-11-21', '2016-11-23',  '2016-11-24')),
                     y = c(2, 4, 4)) %>% pad

counts %>% fill_by_value()
counts %>% fill_by_value(value = 42)
counts %>% fill_by_function(fun = mean)
counts %>% fill_by_prevalent()
```
Note that in the first `fill_by_value` the columns to fill are not specified. In this case the filling is applied on all the columns. The other two functions also have this default behavior.

## Formatting functions

After aggregating the data to a higher interval, all the observations in an interval are represented by a single point in time. This is either the first (rounding down) or the last (rounding up) datetime point of the interval. Two functions are offered to reformat the datetime variable, so the data might be better represented a table or a graph. First of all, `center_interval` will move the time point to the center of the interval. This would give a better representation in point, line and bar graphs.

```{r, fig.width=7}
emergency %>% 
  thicken("hour", "h") %>% 
  count(h) %>% 
  slice(1:24) %>% 
  mutate(h_center = center_interval(h)) %>% 
  ggplot(aes(h_center, n)) + geom_bar(stat = "identity")
```

The bars are now between the hours, rather than on the hours. More true to the nature of the interval.

Next, there is `format_interval`. This creates a categorical variable that describes the start and end of the interval. This works great with asymmetric data, as shown in the dedicated vignette, but can also be informative with regular intervals. You can specify the way you want the start and the end to be formatted just like you would in `strftime`. 

```{r, message=FALSE}
emergency %>% 
  filter(title == "EMS: HEAD INJURY") %>% 
  thicken("6 hour", "hour6") %>% 
  count(hour6) %>% 
  pad() %>% 
  fill_by_value() %>% 
  mutate(hour6_fmt = 
           format_interval(hour6, start_format = "%Hh", sep = "-")) %>% 
  ggplot(aes(hour6_fmt, n)) +
  geom_boxplot()
```

## Further details
There are two more vignettes. In `padr_implementation` you can find more information about how `padr` handles daylight savings time, what it does with different time zones and how `thicken` exactly is implemented. `padr_custom` shows you how you can thicken and pad with asymmetric intervals.

## Suggestions?
Found a bug? Ideas for improving or expanding `padr`. Your input is much appreciated. The code is maintained at https://github.com/EdwinTh/padr and you are most welcome to file an issue or do a pull request.


[^1]: Many users who work with date and time variables will be using the `lubridate` package. The definition of an interval in `lubridate` is different from the definition in `padr`. In `lubridate` an interval is a period between two time points and has nothing to do with recurrence. Please keep this in mind.

---
title: "Implementation Information of `padr`"
author: "Edwin Thoen"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Implementation Information of `padr`}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Regarding daylight savings time and different time zones, some explicit choices had to be made. They are explained here, so the user knows what to expect when using the `padr` functions. The last paragraph provides detailed information about the workings of `thicken`.

## Daylight savings time
The `padr` package relies heavily on the base R functions `seq.Date` and `seq.POSIXt` to span the date and datetime variables for `thicken` and `pad` In the latter, choices had to be made about ignoring daylight savings time or not. Take the following example.

```{r, message = FALSE, warning= FALSE, }
start_val <- as.POSIXct('2016-03-25 08:15:00', tz = 'CET')
seq(start_val, by = 'day', length.out = 4) 
seq(start_val, by = 'DSTdays', length.out = 4)
```

As the help file of `seq.POSIXt` mentions: 'The difference between "day" and "DSTday" is that the former ignores changes to/from daylight savings time and the latter takes the same clock time each day.' The interval of a datetime variable in the `padr` context is determined by the lowest time unit that differs over the individual datetime observations. When the hour of the observation shifts as a result of daylight savings time this will cause the interval to change from 'day' to 'hour'. This implies that when we pad a variable that has interval 'day', the daylight savings time can't be ignored and we thus take the same clock time everyday. The only other interval that can be distorted by daylight savings time is 'week'.

```{r}
seq(start_val, by = 'week', length.out = 2)
```

Spanning of variables of this interval is therefore implemented as:

```{r}
seq(start_val, by = '7 DSTdays', length.out = 2)
```

## Different time zones
The arguments `start_val` (in `pad` and `thicken`) and `end_val` (in `pad`) can have a different time zone than the input datetime variable. In this case the function will coerce the argument to be of same time zone as the input variable *while keeping the clock time equal*. It does so with throwing a warning. Take the following example:

```{r}
library(padr)
to_pad <- data.frame(dt = seq(as.POSIXct('2016-02-02 14:53:12', tz = 'CET'),
                                         length.out = 2, by = 'day'))
pad(to_pad, start_val = as.POSIXct('2016-02-01 14:53:12', tz = 'EST'))
```

This behavior was chosen over throwing an error or converting to the other time zone with adjusting the clock time, because it is assumed that the user did not use two time zones on purpose. Time zone differences are more likely due to different object sources, rather than being created intentional. For instance using `as.POSIXct` without specifying the time zone, will use the time zone from the System's locale. When creating a datetime variable with `lubridate` on the other hand, it will use *UTC* as the default time zone. 

## Details working `thicken`

`thicken` takes the interval of the input datetime variable and spans a variable of a higher interval around it. When `rounding` is "down" each value in the input variable will be mapped to the closest value in the spanned variable, that is lower or equal than itself. When `rounding` is "up" this is to the closest value that is larger than itself. Graphically this looks like:

<img src="thicken_graph.png" height="400px" width="800px" />

The blue dots are the values of the input datetime variable. The red dots are the timepoints that are spanned around the original time points. In this example the `rounding` is "down", so the original values are mapped to the closest value in spanned, that is earlier than the original.

For all the seven intervals that could be spanned, by default the spanned variable will be as 'tightly' around the input variable as the interval allows. Meaning that the first value of the spanned variable is the latest possible timepoint that is still smaller than the smallest value of the input variable. The last value is the first possible timepoint that is larger than the the largest value of the input variable.

As of version 0.3.0 the user can specify units other than one for each of the interval (e.g. 10 minutes, 2 hours). In order to implement this the default spanning behavior had to change from previous versions. This does not change the result, if the desired interval is of unit one. These are the default start values of the seven intervals that we can `thicken` to. The spanning ends after the last observation in the datetime variable. The first five will be of class `Date`, the last two will be of class `POSIXct`.

* **year** will start on January 1st of the year of the first value of the datetime variable.
* **quarter** will start on one of the following: January 1st, April 1st, July 1st, or October 1st.
* **month** will start on the first day of the month of the first value of the datetime variable.
* **week** will start on a Sunday.
* **day** will start and end on any given day.
* **hour** will start and end on the beginning of the day.
* **minute** will start and end on the beginning of the hour.
